class ChannelStr(object):
    def __init__(self):
        self.cpunum = [0, 1]
        self.channelnum = [13, 14, 15, 16, 17, 18]
        self.channelnumElse = [7, 8]
        self.bankMarking = 0
        self.channels = {
            130: "CH0",
            140: "CH1",
            150: "CH3",
            160: "CH4",
            170: "CH2",
            180: "CH5",
            131: "CH0",
            141: "CH1",
            151: "CH3",
            161: "CH4",
            171: "CH2",
            181: "CH5",
        }
        self.channelsElse = {
            "070": "CH0",
            "071": "CH1",
            "072": "CH2",
            "080": "CH3",
            "081": "CH4",
            "082": "CH5",
            "170": "CH0",
            "171": "CH1",
            "172": "CH2",
            "180": "CH3",
            "181": "CH4",
            "182": "CH5",
        }

    def channelStrElse(self, cpuid, bankid, content):
        if content in [0,1,2]:
            return self.channelsElse[str(cpuid)+str(bankid)+str(content[i])]
        else:
            return "unspecified"


    def channelStr(self, cpuid, bankid, content):
        if bankid not in self.channelnum:
            if bankid not in self.channelnumElse:
                return ""
            if self.bankMarking == 1:
                return ""
            else:
                return self.channelStrElse(cpuid, bankid, content)
        if cpuid not in self.cpunum:
            return ""
        self.bankMarking = 1
        return self.channels[bankid * 10 + cpuid]


if __name__ == "__main__":
    pass
