# -*- coding: utf-8 -*-
# SOFTWARE LICENSE AGREEMENT
# IMPORTANT - READ BEFORE COPYING, INSTALLING OR USING.
# Do not use or load the Software from this site or any Documentation until you have carefully
# read the following terms and conditions. By loading or using the Software, you agree to the
# terms of this Agreement. If you do not wish to agree, do not install or use the Software.
# 1. DEFINITIONS
# 1.1 "Derivative Source Program" means Licensee's source code program that derives from or incorporates
#    all or any portion of the Source Code.
# 1.2 "Documentation" means the user manuals and other written materials that describe the Software,
#    including its operation and matters related to its use, that Intel provides in connection with, under, or subject to,
#    this Agreement, and any updated, improved or modified version(s) of those materials, whether provided in
#    published written material, on magnetic media or communicated by electronic means.
# 1.3 "Intel Licensed Patent Claims" means the claims of Intel's patents that are necessarily and directly
#    infringed by the reproduction and distribution of the Software, as authorized in Section 2, when those items are in
#    their unmodified form as delivered by Intel to you, and not modified or combined with anything else. Licensed
#    Patent Claims are only those claims that Intel can license without paying, or getting the consent of, a third party.
# 1.4 "Open Source Software" means any software that requires as a condition of use, modification and/or
#    distribution of such software that that software or other software incorporated into, derived from or distributed
#    with that software: (a) be disclosed or distributed in Source Code; (b) be licensed by the user to third parties for
#    the purpose of making or distributing derivative works; or (c) be redistributable at no charge.
# 1.5 "Software" means all software, in Source Code format, downloaded from this site.
# 1.6 "Source Code" means a form in which a computer program's logic is easily deduced by a human being
#    with skill in the art, such as a printed listing of the program or a form from which a printed listing can be easily
#    recognized.
# 2. LICENSE GRANT
# 2.1 Grant. Subject to the limitations set forth in Section 2.3, Intel hereby grants you, during the term of this
#    Agreement, a non-transferable, royalty-free, non-exclusive, limited right and license:
#    (A) under Intel's copyrights, to:
#        (1) copy, and make a reasonable number of copies of all or any portion of the Software for
#        the purpose of internally validating and debugging Intel(R) Xeon(R), Intel(R) Xeon Phi(TM),
#        Intel(R) Atom(TM) processors, and/or Intel(R) chipsets. ("Purpose');
#        (2) prepare Derivative Source Programs of the Software for the Purpose;
#        (3) copy, distribute and use the Documentation as is reasonably necessary for you to
#        exercise Intel's license rights under this Section 2.1.
#    (B) Under Intel's Licensed Patent Claims, to:
#        (1) use the Software internally only for the Purpose.
#        The Licensed Patent Claims do not and will not apply to any modifications to, or
#        Derivative Source Programs of, the Software, whether made by you or any third party,
#        except to the limited extent the modifications and Derivative Source Programs are
#        permitted under 2.1(A)(2).2
# 2.2 Restrictions.
#    (A) All rights, title and interest in and to the Software and Documentation are and will remain the
#    exclusive property of Intel. Unless expressly permitted under Section 2.1, the Software and
#    Documentation are subject to the following restrictions:
#        (1) you may make back-up copies of the Software, provided such copies are stored in a
#         secured area. Otherwise, you may not copy, modify, rent, sell, distribute or transfer any
#        part of the Software except as provided in this Agreement, and you agree to prevent
#        unauthorized copying of the Software.
#        (2) you acknowledge that the Software may contain the software or other property of third
#        party suppliers, some of which may be identified in, and licensed in accordance with,
#        any enclosed "license.txt" file or other text or file.
#        (3) you shall not, nor shall you allow any third party to, reverse engineer, decompile,
#        synthesize or reverse-assemble the Software except to the extent required for
#        interoperability purposes under applicable laws or as expressly permitted in open source
#        licenses.
#        (4) you shall not, nor shall you allow any third party to, publish or provide any Software
#        benchmark or comparison of test results.
#    (B) The consideration under this Agreement is only for the licenses that Intel expressly grants to you in
#    Section 2.1. Any other rights including, but not limited to, additional patent rights, will require an
#    additional license, express and in writing, and additional consideration. Nothing in this Agreement
#    requires or will be treated to require Intel to grant any additional license. You acknowledge and agree that
#    an essential basis of the bargain in this Agreement is that Intel grants you no licenses or other rights
#    including, but not limited to, patent, copyright, trademark, trade name, service mark or other intellectual
#    property licenses or rights with respect to the Software and Documentation, by implication, estoppel or
#    otherwise, except for the licenses expressly granted in Section 2.1. Specifically, except for the licenses
#    that Intel expressly granted you in Section 2.1, Intel grants no licenses or other rights, expressly or by
#    implication, estoppel or otherwise, to:
#        (1) make, use, sell, offer for sale, or import modifications of the Software;
#        (2) sell or offer to sell the Software;
#        (3) combine the Software or modified versions of the Software with other items or to use any such
#        combination; or
#        (4) any claims of any patents, patent applications, or other patent rights of Intel other than the
#        Licensed Patent Claims.
#    The Software is protected by the intellectual property laws of the United States and other countries, and
#    international treaty provisions. An essential basis of the bargain in this Agreement is that no licenses or
#    other rights, including but not limited to patent and copyright licenses or rights, are granted to you by
#    implication, estoppel or otherwise, except for the licenses expressly granted in the preceding paragraphs.
#    (C) If the Software includes any Open Source Software, that Open Source Software is licensed under the
#    applicable Open Source Software license agreement identified in the comments in the applicable Source
#    Code file(s) and/or file header provided with the Software. With respect to the Open Source Software,
#    nothing in this Agreement limits any rights under, or grants rights that supersede, the terms of the
#    applicable Open Source Software license agreement.
# 3. OWNERSHIP OF SOFTWARE AND COPYRIGHTS. Title to all copies of the Software and any updates
#   provided remains with Intel or its suppliers. Title in and to the Derivative Source Program shall be held by You or
#   Your suppliers as appropriate, subject to Intel's underlying ownership of the Software. You may not mortgage,3
#   pledge or encumber any of the Software in any way. You may not remove any copyright notices from the Software.
#   Intel may make changes to the Software, or to items referenced therein, at any time without notice, but is not
#   obligated to support or update the Software. Except as otherwise expressly provided, Intel grants no express or
#   implied right under Intel patents, copyrights, trademarks, or other intellectual property rights.
# 4. EXCLUSION OF WARRANTIES. INTEL MAKES NO WARRANTY OF ANY KIND REGARDING THE
#   SOFTWARE. THE SOFTWARE IS LICENSED TO YOU ON AN "AS IS" BASIS AND INTEL WILL NOT
#   PROVIDE ANY SUPPORT, ASSISTANCE, INSTALLATION, TRAINING OR OTHER SERVICES. INTEL
#   WILL NOT PROVIDE ANY UPDATES, ENHANCEMENTS OR EXTENSIONS TO THE SOFTWARE.
#   INTEL SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
#   NONINFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
# 5. LIMITATION OF LIABILITY. IN NO EVENT SHALL INTEL OR ITS SUPPLIERS BE LIABLE FOR ANY
#   DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, LOST PROFITS, BUSINESS
#   INTERRUPTION, OR LOST INFORMATION) ARISING OUT OF THE USE OF OR INABILITY TO USE
#   THE SOFTWARE, EVEN IF INTEL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#   SOME JURISDICTIONS PROHIBIT EXCLUSION OR LIMITATION OF LIABILITY FOR IMPLIED
#   WARRANTIES OR CONSEQUENTIAL OR INCIDENTAL DAMAGES, SO THE ABOVE LIMITATION
#   MAY NOT APPLY TO YOU. YOU MAY ALSO HAVE OTHER LEGAL RIGHTS THAT VARY FROM
#   JURISDICTION TO JURISDICTION.
# 6. INDEMNITY. You shall indemnify, defend and hold Intel, its affiliates, its officers, directors, and employees,
#   harmless from and against any third party claims, demands, actions, costs and expenses (as ordered by a court of
#   competent jurisdiction and including reasonably attorney's fees) and damages awarded against Intel or a settlement
#   agreed to by Intel, relating to or otherwise arising from your use, modification or distribution of the Software under
#   this Agreement.
# 7. TERMINATION. Intel may immediately terminate this Agreement at any time if you violate its terms. If this
#   Agreement is terminated for any reason, you will cease distribution of the Software and Documentation, and, at
#   Intel's option and within thirty (30) days following termination, either returns to Intel or destroy the original and
#   all copies of the Software and Documentation and certify to Intel that they have been destroyed.
# 8. NO SUPPORT. Intel has no obligation to maintain or support the Software or Documentation. You are directed
#   to access Intel's webpage, [http://software.intel.com/en-us/], for basic FAQ's and other Intel product resources
#   relating to the Software. Under no circumstances will Intel have any obligation to your customers with respect to
#   maintenance or support of the Software.
# 9. APPLICABLE LAWS. Claims arising under this Agreement shall be governed by the laws of Delaware,
#   excluding its principles of conflict of laws and the United Nations Convention on Contracts for the Sale of Goods.
#   You may not export the Software in violation of applicable export laws and regulations. Intel is not obligated under
#   any other agreements unless they are in writing and signed by an authorized representative of Intel.
# 10. GOVERNMENT RESTRICTED RIGHTS. The Software is provided with "RESTRICTED RIGHTS." Use,
#   duplication, or disclosure by the Government is subject to restrictions as set forth in FAR52.227-14 and
#   DFAR252.227-7013 et seq. or its successor. Use of the Software by the Government constitutes acknowledgment
#   of Intel's proprietary rights therein. Contractor or Manufacturer is Intel Corporation, 2200 Mission College Blvd.,
#   Santa Clara, CA 95052.
# 11. TRADEMARKS. You may not use Intel's name in any publications, advertisements, or other announcements
#   without Intel's prior written consent. You do not have any rights to use Intel's trademarks under any circumstances.4
# 12. AUDIT RIGHTS. Intel shall have the right to inspect or have an independent auditor inspect your facilities and
#   records to verify your compliance with the terms and conditions of this Agreement. If such an inspection discloses
#   you are not compliant with these terms, Intel may exercise any or all rights and remedies provided under this
#   Agreement or by law, including but not limited to the right to recover the cost of such audit.
# 13. GENERAL
# 13.1 The Software may be controlled for export purposes by the U.S. Government. You will not export, either
#     directly or indirectly, any Software without Intel's prior consent and without first obtaining any required
#     license or other approval from the U.S. Department of Commerce or any other agency or department of
#     the United States Government as required.
# 13.2 This is the entire agreement between you and Intel relating to this subject matter, and no amendments will
#     be effective unless in writing signed by both parties.
# 13.3 You may not assign this agreement or any part of it except with Intel's prior written consent.
# 13.4 The terms and conditions stated herein are declared to be severable. If any paragraph, provision, or clause
#     in this Agreement shall be found or be held to be invalid or unenforceable in any jurisdiction in which
#     this Agreement is being performed, the remainder of this Agreement shall be valid and enforceable and
#     the parties shall use good faith to negotiate a substitute, valid and enforceable provision which most nearly
#     effects the parties' intent in entering into this Agreement.

# !/usr/bin/env python
"""
    Module: mcd.py

    Package Dependency: None
    Description:
        This is a standalone MCA(Machine Check Architecture) decoder.
        Users could run the script as 1) manual decoding; or 2) pass in command line parameters.
        Please see the usage instruction document in the same script folder.

    Autor: Oscar Aguirre
    Date: January 22, 2016
"""

import textwrap as _textwrap
import sys

_revString = '2016.01.22 - SKX'
_decodeList = [
    {'bankType': 'IFU', 'fieldMask': 0x00000000000f0000, 'AndMask': 0x0000000000000005, 'OrMask': 0xffffffffffff0005,
     'genDesc': 'IFU Internal Parity Error', 'decode': {
        0: ['Register File Parity Error ',
            'Register file buffer reported machine check. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivities to voltage, frequency and temperature. In a properly functioning part an effort of this kind can manifest itself by operating the part out of specified tolerances. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. In the non compounded case, this error is expected to assert the MCERR# variant of the error. ',
            '更换CPU'],
        1: ['DSB Parity Errors',
            'Data sequencer buffer parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivities to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. In the non compounded case, this error is expected to assert the MCERR# variant of the error. ',
            '更换CPU'],
        2: ['MS uRAM Parity Error',
            'Micro sequencer uRam parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivities to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.  In the non compounded case, this error is expected to assert the MCERR# variant of the error. ',
            '更换CPU'],
        3: ['Instruction Queue Parity Error ',
            'Instruction queue parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivities to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.  In the non compounded case, this error is expected to assert the MCERR# variant of the error. ',
            '更换CPU'],
        4: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        5: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        6: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        7: ['Instruction Decode Queue Parity Error  ', '', 'NA'],
        8: ['Branch Array Parity Error   ', '', 'NA'],
        9: ['MS Unique ROM Parity Error', '', 'NA'],
        10: ['MS Pointer ROM Parity Hard Error', '', 'NA'],
        11: ['MS Pointer ROM Parity Recoverable Error', '', 'NA'],
        12: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        13: ['Undefined Encoding', 'Undefined encoding', 'NA'],
        14: ['Undefined Encoding', 'Undefined encoding', 'NA'],
        15: ['Inclusion Error',
             'Operation violates the inclusion property of the cache structures.  The requested instruction is no longer in the cache domain (which is what the inclusion property implies).  An error of this type is likely core voltage related or a specific part failure. ',
             '重启观察CPU']
    }},
    {'bankType': 'IFU', 'fieldMask': 0x00000000000f0000, 'AndMask': 0x0000000000000100, 'OrMask': 0xffffffffffff01f0,
     'genDesc': 'IFU Parity Error    ', 'decode': {
        0: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        1: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        4: ['ICache Data Parity Error ',
            'Poison signature in the IFU. This implies the data received by the IFU was inverted as part of a poison event. The origin of the error is elsewhere.  Check for poison forwarding mode and other MCA Status banks. In a poison enabled failure case, the source of the error should have logged a corrected error. This implies that the MCA bank logs may not be sufficient given there is a time element to this. The originating failure will have been logged and signaled via CMCI. The operating system should contain logs of this source stream.   The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.',
            '重启观察（主板CPU）'],
        5: ['ICache Tag Parity Error',
            'Icache tag parity error. This type of error should be a very rare event under normal operating conditions.   If this error is repeatable in any domain, it is likely core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.',
            '更换主板'],
        6: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        7: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        8: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        9: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        10: ['Unexpected Encoding',
             'Unexpected combination of mscod/mcacod', 'NA'],
        11: ['Unexpected Encoding',
             'Unexpected combination of mscod/mcacod', 'NA'],
        12: ['Unexpected Encoding',
             'Unexpected combination of mscod/mcacod', 'NA'],
        13: ['Undefined Encoding', 'Undefined encoding', 'NA'],
        14: ['Undefined Encoding', 'Undefined encoding', 'NA'],
        15: ['Unexpected Encoding',
             'Unexpected combination of mscod/mcacod', 'NA']}},
    {'bankType': 'IFU', 'fieldMask': 0x00000000000f0000, 'AndMask': 0x0000000000000010, 'OrMask': 0xffffffffffff0010,
     'genDesc': 'ITLB Parity Error   ',
     'decode': {0: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                1: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                4: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                5: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                6: ['ITLB Linear or Physical Parity Errors',
                    'ITLB parity error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
                    '更换主板'],
                7: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                8: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                9: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                10: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                11: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                12: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
                13: ['Undefined Encoding', 'Undefined encoding', 'NA'],
                14: ['Undefined Encoding', 'Undefined encoding', 'NA'],
                15: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA']}},
    {'bankType': 'IFU', 'fieldMask': 0x00000000000f0000, 'AndMask': 0x0000000000000406, 'OrMask': 0xffffffffffff0406,
     'genDesc': 'Internal Control Flow Errors',
     'decode': {0: ['Ucode Trusted Paths Error', 'Microcode control flow error', 'FW报错，重启观察'],
                1: ['Undefined Encoding', '', 'NA'],
                2: ['Patch RAM Protection Trusted Paths Error', 'Microcode update control flow error', 'FW报错，重启观察'],
                3: ['Undefined Encoding ', '', 'NA'],
                4: ['C6 SRAM Protection Trusted Paths Error', 'Illegal access error', 'FW报错，重启观察'],
                5: ['Undefined Encoding', '', 'NA']}},
    {'bankType': 'DCU', 'fieldMask': 0x0000000000200000, 'AndMask': 0x0000000000200401, 'OrMask': 0xffffffffff200401,
     'genDesc': 'DCU APIC Error      ', 'decode': {
        0: ['Reserved', 'Reserved Encoding', 'NA'],
        1: ['APIC Error',
            'An error was detected and the address range was in the APIC region. A common error of this type is related to incorrect cachebility type for the APIC region. Check to see the mapping of the APIC region is correct (uncacheable).',
            'FW报错，重启观察']}},
    {'bankType': 'DCU', 'fieldMask': 0x0000000000200000, 'AndMask': 0x0000000000000104, 'OrMask': 0xffffffffffef01f4,
     'genDesc': 'DCU Parity Error    ', 'decode': {
        0: ['DCU Parity Error', '', 'NA'],
        1: ['APIC Error',
            'An error was detected and the address range was in the APIC region. A common error of this type is related to incorrect cachebility type for the APIC region. Check to see the mapping of the APIC region is correct (uncacheable).',
            'FW报错，重启观察']}},
    {'bankType': 'DCU', 'fieldMask': 0x0000000000100000, 'AndMask': 0x0000000000100174, 'OrMask': 0xffffffffff100174,
     'genDesc': 'DCU Parity Error    ', 'decode': {
        0: ['Reserved', 'Reserved Encoding', 'NA'],
        1: ['WBINVD Error',
            'This error code represents a data error WBINV cycle. This is not a software generated event.  The error is uncorrectable but in some cases the escalation may (poison enabled) be deferred or delayed. In any event, the cause of the failure is likely to be related to power delivery to the cores. The implication is that this error can appear as an MCE or as a CMCI event. One can check for the condition based on the UC, PCC, S and AR bits of MCi_STATUS to understand which variant of the error escalation flow this is logged in.',
            '更换主板']}},
    {'bankType': 'DCU', 'fieldMask': 0x0000000000100000, 'AndMask': 0x0000000000100134, 'OrMask': 0xffffffffff100134,
     'genDesc': 'DCU Parity Error    ', 'decode': {
        0: ['Reserved', 'Reserved Encoding', 'NA'],
        1: ['Poison Error',
            'An uncorrected error has been detected on a DCU cycle (see MCACOD bits for transaction type). This is uncorrected. This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
            '更换主板']}},
    {'bankType': 'DTLB', 'fieldMask': 0x0000000000070000, 'AndMask': 0x0000000000000005, 'OrMask': 0xffffffffffff0005,
     'genDesc': 'Internal Parity Error',
     'decode': {0: ['Reserved', '', 'NA'],
                1: ['Reserved', '', 'NA'],
                2: ['Internal Reg File Parity Error', '', '检查CPU主板（CPU电源）环温'],
                3: ['Reserved', '', 'NA'],
                4: ['Internal Reg File Parity Error', '', '检查CPU主板（CPU电源）环温'],
                5: ['Reserved', '', 'NA']}},
    {'bankType': 'DTLB', 'fieldMask': 0x0000000000030000, 'AndMask': 0x0000000000000010, 'OrMask': 0xffffffffffff001c,
     'genDesc': 'DTLB Parity Error   ',
     'decode': {0: ['DTLB Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                1: ['DTLB Data Parity Error', '', '检查CPU主板（CPU电源）环温'],
                2: ['PDE Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                3: ['PDE Data Parity Error', '', '检查CPU主板（CPU电源）环温']}},
    {'bankType': 'DTLB', 'fieldMask': 0x0000000000030000, 'AndMask': 0x0000000000000011, 'OrMask': 0xffffffffffff001d,
     'genDesc': 'STLB Parity Error   ',
     'decode': {0: ['STLB Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                1: ['STLB Data Parity Error', '', '检查CPU主板（CPU电源）环温'],
                2: ['PDE Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                3: ['PDE Data Parity Error', '', '检查CPU主板（CPU电源）环温']}},
    {'bankType': 'DTLB', 'fieldMask': 0x0000000000030000, 'AndMask': 0x0000000000000012, 'OrMask': 0xffffffffffff001f,
     'genDesc': 'TLB Parity Error',
     'decode': {0: ['TLB Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                1: ['TLB Data Parity Error', '', '检查CPU主板（CPU电源）环温'],
                2: ['PDE Tag Parity Error', '', '检查CPU主板（CPU电源）环温'],
                3: ['PDE Data Parity Error', '', '检查CPU主板（CPU电源）环温']}},
    {'bankType': 'DTLB', 'fieldMask': 0x00000000000f0000, 'AndMask': 0x0000000000000406, 'OrMask': 0xffffffffffff0406,
     'genDesc': 'Internal Control Flow Errors',
     'decode': {0: ['Reserved', '', 'NA'],
                1: ['Reserved', '', 'NA'],
                2: ['Reserved', '', 'NA'],
                3: ['Internal Control Flow Error', '', '检查CPU主板（CPU电源）环温'],
                4: ['Internal Control Flow Error', '', '检查CPU主板（CPU电源）环温'],
                5: ['Reserved', '', 'NA']}},
    {'bankType': 'MLC', 'fieldMask': 0x0000000000800000, 'AndMask': 0x0000000000000400, 'OrMask': 0xffffffffffff0400,
     'genDesc': 'Internal Error      ', 'decode': {
        0: ['No Error', '', '重启观察'],
        1: ['Watchdog Timer (3-strike) Error',
            'No core uops retired within the watchdog  timeout value. This value is nominally set to 21.47 seconds. This is not necessarily indicative of a CPU issue. The most common cause of this issue is a non-completion of a transaction by an external agent. The basic debug of this type of issue is to isolate this outstanding transaction. If the crashdump process is enabled for this platform, use the data for further fault isolation. The crashdump will extract outstanding transactions from the LLC ( Cbo TOR - Cbox Table of Requests). One of these is likely to be the source of the timeout condition.  Pay particular attention to the core id (not the same as APIC ID but can be derived) of this MCA bank and correlate it to the core id of the Cbo TOR array entries. There may be other side effect entries in the TOR, these could be disregarded.  This process will yield a starting point. The next step is to understand why this outstanding transaction has not been completed. One normally has to extract a system memory map from the failing UUT in order to isolate where in the system the address was targeted towards. This would be the basis of the next stage of the debug.',
            '更换CPU']}},
    {'bankType': 'MLC', 'fieldMask': 0x0000000000400000, 'AndMask': 0x0000000000000400, 'OrMask': 0xffffffffffff0407,
     'genDesc': 'Internal Error      ',
     'decode': {0: ['No Error', '', 'NA'], 1: ['Internal Queue Parity Error', '', '重启观察'], 2: ['Reserved', '', 'NA']}},
    {'bankType': 'MLC', 'fieldMask': 0x0000000000300000, 'AndMask': 0x0000000000000101, 'OrMask': 0xffffffffffff11fd,
     'genDesc': 'MLC Error           ', 'decode': {
        0: ['MLC Data No Error', '', 'NA'],
        1: ['MLC Data Single Error',
            'MLC Data Read corrected error.  The MLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).',
            '检测CPU主板（CPU电源）环温'],
        2: ['MLC Data Double Error',
            'MLC Data Read error.  This is an uncorrected error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance]. If this error is coupled with previous failure data (a long succession of single bit errors with a TES state changing to Yellow), then it may be a sign of a part degrading.',
            '检测CPU主板（CPU电源）环温'],
        3: ['Reserved', '', 'NA']}},
    {'bankType': 'MLC', 'fieldMask': 0x00000000000c0000, 'AndMask': 0x0000000000000101, 'OrMask': 0xffffffffffff11fd,
     'genDesc': 'MLC Error           ', 'decode': {
        0: ['MLC MESI No Error', '', 'NA'],
        1: ['MLC MESI Corrected Error',
            'MLC single bit corrected error in MESI state structure. The MLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).',
            '检测CPU主板（CPU电源）环温'],
        2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA'],
        3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA']}},
    {'bankType': 'MLC', 'fieldMask': 0x0000000000030000, 'AndMask': 0x0000000000000101, 'OrMask': 0xffffffffffff11fd,
     'genDesc': 'MLC Error           ', 'decode': {
        0: ['MLC Tag No Error', '', 'NA'],
        1: ['MLC Tag Single Error',
            'The MLC structure has detected a tag parity error (single bit error, uncorrected).   Failures of this type are very rare events under normal operating conditions.   If this error is repeatable in any domain, it is likely a core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.',
            '更换CPU'],
        2: ['MLC Tag Double Error',
            'The MLC structure has detected a tag parity error (double bit error, uncorrected).   Failures of this type are very rare events under normal operating conditions.   If this error is repeatable in any domain, it is likely a core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.',
            '更换CPU'],
        3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod', 'NA']}},
    {'bankType': 'PCU', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x0000000000000402, 'OrMask': 0xffffffffffff0402,
     'genDesc': 'PCU FW Errors', 'decode': {
        0x0e: ['MCA_DMI_TRAINING_TIMEOUT',
               'During reset, DMI training failed to complete within time-out. Possible DMI related failure.',
               '检查CPU主板（CPU电源）环温'],
        0x0f: ['MCA_DMI_STRAP_SET_ARRIVAL_TIMEOUT',
               'STRAP SET Message form PCH was not received in time; Possible DMI Issue.', ''],
        0x10: ['MCA_DMI_CPU_RESET_ACK_TIMEOUT',
               'During reset, DMI message for CPU Reset Ack did not arrive within timeout. Possible DMI related failure.',
               '检查CPU主板（CPU电源）环温'],
        0x11: ['MCA_MORE_THAN_ONE_LT_AGENT',
               'During Boot Mode Processing, >1 Intel TXT Agent detected. Possible Intel UPI BIOS/BMC setting issue.',
               '重启观察'],
        0x12: ['MCA_MEMORY_RCOMP_TIMEOUT',
               'First RCOMP for Memory not completed in time; Possible BIOS configuration issue.', ''],
        0x14: ['MCA_INCOMPATIBLE_PCH_TYPE',
               'PCH being used is not compatible with the CPU it is paired with; Possible Platform configuration issue.',
               ''],
        0x1e: ['MCA_BIOS_RST_CPL_INVALID_SEQ',
               'BIOS violated BIOS Reset CPL sequencing requirements. Possible BIOS related issue.', '重启观察'],
        0x1f: ['MCA_BIOS_INVALID_PKG_STATE_CONFIG', 'BIOS Invalid PKG State Configuration. Possible BIOS issue.', ''],
        0x25: ['MCA_MESSAGE_CHANNEL_TIMEOUT',
               'Timeout while sending something to the Message Channel (posted or non-posted).', ''],
        0x27: ['MCA_MSGCH_PMREQ_CMP_TIMEOUT', 'Timeout waiting for PMReq.CMP to be set', '重启观察'],
        0x30: ['MCA_PKGC_DIRECT_WAKE_RING_TIMEOUT', 'Timeout on package C-state.', ''],
        0x31: ['MCA_PKGC_INVALID_RSP_PCH', 'Invalid Response from the PCH. Possible DMI issue.', ''],
        0x33: ['MCA_PKGC_WATCHDOG_HANG_CBZ_DOWN',
               'Pkg C-state hung at transient state: In Buffer Zone, going Down (towards C2/C3).Possible Intel UPI related failure.',
               '更换主板'],
        0x34: ['MCA_PKGC_WATCHDOG_HANG_CBZ_UP',
               'Pkg C-state hung at transient state: In Buffer Zone, going Up (towards C0). Possible Intel UPI or DMI related failure.',
               '更换主板'],
        0x38: ['MCA_PKGC_WATCHDOG_HANG_C3_UP_SF',
               'Pkg C-state hanged at transient state: In C3, towards C2, slow/fast voltage ramp.', '更换主板'],
        0x40: ['MCA_SVID_VCCIN_VR_ICC_MAX_FAILURE', 'SVID error. Possible VR failure.', ''],
        0x41: ['MCA_SVID_COMMAND_TIMEOUT',
               'SVID command time-out (busy bit was not cleared fast enough). Possible VR related failure.', '更换主板'],
        0x42: ['MCA_SVID_VCCIN_VR_VOUT_FAILURE', 'SVID error. Possible VR failure.', ''],
        0x43: ['MCA_SVID_CPU_VR_CAPABILITY_ERROR', 'SVID Capability error. Possible VR related failure.', ''],
        0x44: ['MCA_SVID_CRITICAL_VR_FAILED', 'SVID Critical VR failed.Possible VR related failure.', ''],
        0x45: ['MCA_SVID_SA_ITD_ERROR', 'SVID error. Possible VR failure.', ''],
        0x46: ['MCA_SVID_READ_REG_FAILED', 'SVID error. Possible VR failure.', ''],
        0x47: ['MCA_SVID_WRITE_REG_FAILED', 'SVID error. Possible VR failure.', ''],
        0x48: ['MCA_SVID_PKGC_INIT_FAILED', 'SVID error. Possible VR failure.', ''],
        0x49: ['MCA_SVID_PKGC_CONFIG_FAILED', 'SVID error. Possible VR failure.', ''],
        0x4a: ['MCA_SVID_PKGC_REQUEST_FAILED', 'SVID Pkgc request failed.Possible VR related failure.', '更换主板'],
        0x4b: ['MCA_SVID_IMON_REQUEST_FAILED', 'SVID IMON request failed. Possible VR related failure.', '更换主板'],
        0x4c: ['MCA_SVID_ALERT_REQUEST_FAILED', 'SVID ALERT request failed. Possible VR related failure.', '更换主板'],
        0x4d: ['MCA_SVID_MCP_VR_RAMP_ERROR', 'SVID error. Possible VR failure.', ''],
        0x51: ['MCA_FIVR_CATAS_OVERVOL_FAULT', 'Catastrophic over voltage IVR fault.', '更换主板'],
        0x52: ['MCA_FIVR_CATAS_OVERCUR_FAULT', 'Catastrophic overcurrent FIVR fault.', '更换主板'],
        0x58: ['MCA_WATCHDOG_TIMEOUT_PKGC_SLAVE',
               'PkgC slave timedout waiting for PmRsp from Master. Possible Intel UPI or Ubox configuration related failure.',
               '重启观察'],
        0x59: ['MCA_WATCHDOG_TIMEOUT_PKGC_MASTER',
               'PkgC master timed-out waiting for PmRsp from PCH. Possible PCH or DMI related failure.', '重启观察'],
        0x5a: ['MCA_WATCHDOG_TIMEOUT_PKGS_MASTER',
               'PkgS master timed-out waiting for PmRsp from slave. Possible Intel UPI or Ubox configuration related failure.',
               '重启观察'],
        0x61: ['MCA_PKGS_CPD_UNCPD_TIMEOUT',
               'Time out trying to drain queue. Possibly due to other component preventing processor to drain.', ''],
        0x63: ['MCA_PKGS_INVALID_REQ_PCH', 'Invalid request from PCH.Possible DMI issue.', ''],
        0x64: ['MCA_PKGS_INVALID_REQ_INTERNAL', 'Invalid request. Possible Intel UPI issue.', ''],
        0x65: ['MCA_PKGS_INVALID_RSP_INTERNAL', 'Invalid response. Possible Intel UPI issue.', ''],
        0x6b: ['MCA_PKGS_SMBUS_VPP_PAUSE_TIMEOUT', 'SMBUS VPP Pause Timeout. Possible SMBUS issue.', '']}},
    {'bankType': 'QPI', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x00000000ffff0000, 'OrMask': 0xffffffff0000ffff,
     'genDesc': 'QPI Errors', 'decode': {
        0: ['QPI Error - Phy Control Error',
            'This error code is unexpected for HSX as it is not designed to signal a phy control error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment).\n',
            '检查CPU主板（CPU电源）环温'],
        32: ['QPI Error - Correctable: Phy Initialization Abort',
             "QPI Link was not able to go through a normal training sequence and had to be aborted and reattempted. The errors are logged in 'QPIREUT_PH_PPS' for the particular port [B: 1 D:[9:8] F:3 O:144h. This register is the Phy later previous initialization status and it captures state information related to the aborted sequence. One will have to have some knowledge of QPI link training to make use of this information. There are good writeups of link training debug in the platform debug handbook.",
             '重启观察'],
        2: ['QPI Error - Physical Layer Detected Drift Buffer Alarm',
            'QPI Error - Drift buffer Overrun. Additional debug information is stored in QPIREUT_PH_PLS  register.  Bits 20:16 log the first lane to report a drift buffer alarm. Bits 6-4 also have additional drift buffer statusing.  An error of this type may point to an electrical issue the other register info may help for isolation.',
            '更换主板'],
        3: ['QPI Error - Physical Layer Detected Latency Buffer Rollover',
            'QPI Error - Latency buffer Over/Under run. Additional debug information is stored in the QPIREUT_PH_PLS register (bit 2).  This error code should only occur in cases or instances where latency fixing is being performed on the platform.  The implication is that the latency values should be adjusted (lengthen) to ensure that the buffers are not being overrun.',
            '重启观察'],
        48: ['QPI Error - Correctable: Rx CRC Error with LLR Success no Phy reset',
             ' A QPI Rx CRC Error which required a link level retry  has been detected.  Escalation to a physical layer reinitialization was not necessary.  This is considered a temporary physical layer event.',
             '检查CPU主板（CPU电源）环温'],
        49: ['QPI Error - Correctable: Tx CRC Error',
             'QPI Tx received a link level retry. This error is normally recommend to be disabled as it is a side effect of Rx CRC error on the other end of the QPI link. This is considered a temporary soft error type of event.',
             '重启观察'],
        35: ['QPI Error - Correctable: Rx CRC Error with LLR success after phy reset',
             'QPI Physical Layer detected a QPI inband reset which resulted in a Width Change . This is not supported on HSX-EN/EP and should never be seen in those SKUs.  For HSX-EX, this code may be reported for a clock fail over event.  To identify the failed lane, check the QPIREUT_PH_TDS/RDS registers. ',
             '检查CPU主板（CPU电源）环温'],
        33: ['QPI Error - Correctable: Phy Inband Reset and Width Degradation ',
             'QPI Physical Layer detected a QPI inband reset which resulted in a Width Change (lane failover). This is not supported on HSX-EN/EP and should never be seen in those SKUs.  For HSX-EX, this code may be reported for a link fail over event.  To identify the failed lane, check the QPIREUT_PH_TDS/RDS registers.\n\nNote for IVT/HSX - this error code will pretty much always be overwritten by 0x31 please consult the TDS/RDS registers to isolate the details of the width change.  ',
             '检查CPU主板（CPU电源）环温'],
        34: ['QPI Error - Correctable: Phy Inband Reset and no width change',
             'QPI Physical Layer detected a QPI inband reset. Width did not change. One failure in isolation is normally not a concern, repeated failures and logging of this error code would imply link health issues.',
             '检查CPU主板（CPU电源）环温'],
        50: ['QPI Error - TX Detected CRC',
             'This error code is legal and valid but normally not expected as it is recommended that masking is used to disable this error logging and escalation.  The first thing to check for is proper mode (did we want to disable this escalation or not). If the intent was to disable the logging/signaling then it becomes an exercise in calculating the recipe to mask the error. This is normally defined in the BIOS writers guide.',
             '重启观察'],
        16: ['QPI Error - Link Layer Detected Control Error from R3QPI ',
             'QPI link layer detected control error or R3QPI error. This type of error should be a very rare event under normal operating conditions.   It is possible for a credit configuration issue can generate this error code. A credit issue can translate to overrun or underflow of a R3QPI internal buffering structure.  Another possibility is that there may be e a parity error in the same structures in EP sku platforms when Viral is not enabled).',
             '重启观察'],
        17: ['QPI Error - Failed Link Layer Retry',
             'QPI Rx detected a CRC error and was not able to recover through Link Layer Replay and Re-Init (LLR Abort state). Essentially the link could not recover from a detected CRC error. This could be an interface issue (bus or bus margin) or some environmental factor (pin/socket issues) or an issue with a specific part.',
             '检查CPU主板（CPU电源）环温'],
        18: ['QPI Error - Unsupported/Undefined Packet',
             'QPI Link Layer detected an unsupported/undefined packet (e.g. RSVD_CHK, message class, op code, VN, viral). An error of this type that is not accompanied by CRC errors is a link layer issue (not physical layer problem). This implies potential programming or interface to another agent (node controller) that may incorrectly fill in fields of the packet.',
             '检查CPU主板（CPU电源）环温'],
        19: ['QPI Error - Link Layer Control Error',
             'Generic QPI Link Layer Error which cannot be resolved. Most occurrences are bi-product of poor general link health.',
             '重启观察'],
        20: ['QPI Error - Link Layer L0p Retrain Error',
             'This error condition is not expected on HSX platforms. HSX behavior is to trigger an inband reset flow on this condition (this differs from previous generations).  If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment).',
             '检查CPU主板（CPU电源）环温'],
        21: ['QPI Error - Link Layer RBT Error',
             'Route Back Table (RBT) error. Uninitialized value used. The implication is that the RBT has not been programmed correctly.  Check the RBT programming sequence to verify that this process has been completed by the platform FW and that this has been done correctly.',
             '检查CPU主板（CPU电源）环温'],
        22: ['QPI Error - Reserved',
             'This error should not be visible, it is reserved for IVB-EP/EX usage. It is not expected to be seen on this platform. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment).',
             '检查CPU主板（CPU电源）环温'],
        31: ['QPI Error - Unsupported Configuration Request from Message Channel',
             'QPI Configuration access crossing a 32 bit boundary.  The QPI subsystem on the socket has received a configuration request that crosses a 32 bit boundary. This is not allowed. ',
             '重启观察']}},
    {'bankType': 'IIO', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x000000000000ffff, 'OrMask': 0xffffffffffff0000,
     'genDesc': 'IIO Generic Error', 'decode': {
        0: ['Generic Error',
            'See PCIe error status values for specific decoders.  This is an EX SKU feature only.  The MCI_MISC register logs  bus, device, function logs.  This should allow for isolation and correlation of machine check banks to PCIe error status registers. ',
            'NA']}},
    {'bankType': 'HA', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x00000000ffff0000, 'OrMask': 0xffffffff0000ffff,
     'genDesc': 'Home Agent Error', 'decode': {
        32: ['Internal parity error in Home Agent',
             'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
             '检查CPU主板（CPU电源）环温'],
        1: ['HA Error - Read Data Error ',
            'Memory controller read error logged. Note the corrected or uncorrected status in bit 61 of MC_STATUS.  The channel number is logged as part of the MCACOD value. If the error is corrected the corrected error count should note the number of events that have occurred since power on. \n\nIf CMCI is enabled, this count may appear to be the value of the threshold that was set for CMCI signaling. This is because the interrupt will occur on the threshold value and the CMCI handler would normally log the value and clear it.  Note what system configuration has been enabled (CMCI enabled and what the threshold was set to) in order to get an accurate picture of the problem.',
            '更换内存'],
        2: ['HA Error - Data Buffer Parity',
            'HA data buffer parity error.  This error represents a bit flip in the data buffer or a parity error on the read path from iMC to HA.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
            '检查CPU主板（CPU电源）环温'],
        4: ['HA Error - Partial Write',
            'A partial memory write error has occurred. This is due to an underfill read error.',
            '检查CPU主板（CPU电源）环温'],
        8: ['HA Error - Rx timing violation',
            'Data from the MC to the HA has violated a timing restriction.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
            '检查CPU主板（CPU电源）环温'],
        64: ['Internal parity error in Home Agent',
             'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
             '检查CPU主板（CPU电源）环温'],
        128: ['Internal parity error in Home Agent',
              'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
              '检查CPU主板（CPU电源）环温'],
        256: ['Internal parity error in Home Agent',
              'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
              '检查CPU主板（CPU电源）环温'],
        16: ['HA Error - RTID Out of Range',
             'An RTID value was generated and checked to be out of range by the HA. The RTID source is either the Cbo or QPI. The error is either an internally generated error (Cbo in the same socket as the HA) or external (via QPI).',
             '检查CPU主板'],
        512: ['HA Error - BT_timeout_error',
              "HA Backup tracker timeout error. A HA transaction has timed out. There is little tracking information logged in the MCA status banks for this. If the source of this transaction was local to this socket a corresponding Cbo Timeout should have occurred. If the transaction was from a remote socket, that socket's Cbo Timeout would have expired (check the MCA banks for that socket). If the source transaction is from a node controller device, then it's timeout mechanism should be consulted for the source transaction. This error code and bank error is used more for helping with the fault isolation. In some cases the opcode of the transaction is logged in the MCi_MISC field. If this is valid the decode would appear there.",
              '检查CPU主板']}},
    {'bankType': 'iMC', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x00000000ffff0000, 'OrMask': 0xffffffff0000ffff,
     'genDesc': 'Integrated Memory Controller Error', 'decode': {
        1: ['iMC Error - DDR3 Address Parity Error',
            'iMC an error occurred in the  address/command parity error has been detected. This is detected by the DIMM and signaled back to the iMC. Note the channel number from the Mci_STATUS bank information and isolate to the DIMM for further fault isolation.',
            '检查内存'],
        2: ['iMC Error - HA Wr Data Parity Error', '', '检查内存'],
        4: ['iMC Error - HA Wr Byte Enable Parity Error', '', '检查内存'],
        8: ['iMC Error - Patrol Scrub Error [Corrected]',
            'The patrol scrubber has detected an error and corrected it.  Address logged in MCx_Address bank.  The patrol scrub logged address is only accurate to 4K boundary (lower 12 bits should be ignored). As with all corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.',
            '更换内存'],
        16: ['iMC Error - Patrol Scrub Error [Uncorrected]',
             "The patrol scrubber has detected an uncorrected error. Address is logged in MCx_Address. The patrol scrub logged address is only accurate to 4K boundary (lower 12 bits should be ignored). In the case of poison enabled mode (advanced SKU's only), this error may be escalated to a CMCI and 'deferred'. This would be spelled out in the S and AR bits of the MCi_STATUS banks. As such, CMCI 'rules' apply here.  Similar to corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.",
             '更换内存'],
        32: ['iMC Error - Sparing [Corrected]',
             'A memory sparing event has occurred and the error is corrected. As with all corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.',
             '检查内存'],
        64: ['iMC Error - Sparing [Uncorrected]',
             "A memory sparing event has occurred and the error is uncorrected.  Address is logged in MCx_Address. In the case of poison enabled mode (advanced SKU's only), this error may be escalated to a CMCI and 'deferred'. This would be spelled out in the S and AR bits of the MCi_STATUS banks. As such, CMCI 'rules' apply here.  Similar to corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.",
             '检查内存'],
        128: ['iMC Error - Any Ha Rd Error', '', '检查内存'],
        256: ['iMC Error - WDB Read Parity Error', '', '检查内存'],
        258: ['iMC Error - DDRT WDB parity error', '', '检查内存'],
        259: ['iMC Error - RPQ0 parity error', '', '检查内存'],
        260: ['iMC Error - RPQ1 parity error', '', '检查内存'],
        261: ['iMC Error - WPQ parity error', '', '检查内存'],
        262: ['iMC Error - DDRT write data parity error', '', '检查内存'],
        263: ['iMC Error - DDRT write BE parity error', '', '检查内存'],
        264: ['iMC Error - DDRT link fail', '', '检查内存'],
        512: ['iMC - Error - DDR4 Command Address Parity Error', '', '检查内存'],
        0x0400: ['iMC Error - Uncorr Address Parity Error', '', '检查内存'],
        0x0800: ['iMC Error - Unrecognized request type', '', '检查内存'],
        0x0801: ['iMC Error - Read response to an invalid scoreboard entry', '', '检查内存'],
        0x0802: ['iMC Error - Unexpected read response', '', '检查内存'],
        0x0803: ['iMC Error - DDR4 completion to an invalid scoreboard entry', '', '检查内存'],
        0x0804: ['iMC Error - Completion to an invalid scoreboard entry', '', '检查内存'],
        0x0805: ['iMC Error - Completion FIFO overflow', '', '检查内存'],
        0x0806: ['iMC Error - Correctable parity error', '', '检查内存'],
        0x0807: ['iMC Error - Uncorrectable error', '', '检查内存'],
        0x0808: ['iMC Error - Interrupt received while outstanding interrupt was not ACKed', '', '检查内存'],
        0x0809: ['iMC Error - ERID FIFO overflow', '', '检查内存'],
        0x080a: ['iMC Error - Error on Write credits', '', '检查内存'],
        0x080b: ['iMC Error - Error on Read credits', '', '检查内存'],
        0x080c: ['iMC Error - Scheduler error', '', '检查内存'],
        0x080d: ['iMC Error - DDRT link retry', '', '检查内存'],
        0x080e: ['iMC Error - FNV thermal error', '', '检查内存']}},
    {'bankType': 'CBO', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x00000000ffff0000,
     'OrMask': 0xffffffff0000ffff, 'genDesc': 'LLC Errors', 'decode': {
        1: ['Cbo Error - UC Data Err - Crd (UCNA)',
            'LLC has detected an uncorrected error (multibit) the data array. The transaction type that caused the error are logged in the MCACOD section of the MCi_STATUS bank.  Errors of this sort are expected but are deemed to be rare.  If the occurrence of these errors are frequent, steps should be take to isolate the problem to a specific part or some other system contribution (uncore power delivery or voltage).',
            '检查CPU'],
        2: ['Cbo Error - UC Tag Err',
            'The LLC has detected an uncorrected error (multibit)  in the tag array. The transaction type that caused the error are logged in the MCACOD section of the MCi_STATUS bank.  Errors of this sort are expected but are deemed to be rare.  If the occurrence of these errors are frequent, steps should be take to isolate the problem to a specific part or some other system contribution (uncore power delivery or voltage).',
            '更换主板'],
        3: ['Cbo Error - SAD ERR WBMto_type (VGA, PAM )',
            'This error occurs when the SAD detects an implicit or explicit writeback to  the following regions areas that are deemed to be illegal : 1) Explicit Writeback access to true VGA range or 2) Implicit/Explicit Writeback to PAM region that does not map to non-DRAM.  These errors are likely software generated and the offending code will have to be isolated (memory mapping software).',
            '重启观察'],
        4: ['Cbo Error - SAD_ERR_IA_ACCESS_TO_GSM', '',
            '重启观察'],
        5: ['Cbo Error - SAD ERR Corrupting',
            'This is caused by 1) Set Monitor transaction to MMIO space 2) Cacheable read to VGA region 3) PCIE to SMM: violation that IIO is trying to access CSEG region (VGA region is mapped for CSEG/SMM) 4) SMM RspM: Implicit WB data when VGA/CSEG range is mapped to true VGA 5) CrabRspM: Implicit WB to CRAB_Abort range of MMCFG range. Check for these error conditions in software.',
            '重启观察'],
        6: ['Cbo Error - SAD ERR Non Corrupting',
            'This error is signaled when a CLFlush occurs to VGA/CSEG region of memory. This is not allowed and suggests an incorrect cacheability region to VGA/CSEG.',
            '重启观察'],
        7: ['Cbo Error - Corrected Data Error',
            'The LLC has detected and corrected (single bit error in data) an error. The LLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).',
            '检查CPU主板（CPU电源）环温'],
        8: ['Cbo Error - MEM_POSION_DATA_ERROR', '',
            '重启观察'],
        10: ['Cbo Error - Uncorrected Parity Error',
             'The LLC has detected a parity error on the ring interface. This is an uncorrected error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].',
             '更换主板'],
        11: ['Cbo Error - CORE_WB_MISS_LLC', '', '重启观察'],
        12: ['Cbo Error - TOR_TIMEOUT',
             "The Cbo Table of Request (TOR) timer has expired on a transaction. This status value should be accompanied by valid MISC and ADDR bank register values. The transaction address and type are encoded in those registers. The MISC register will log the: Core ID, Thread ID, Cacheability, Original Request and Opcode.  The Original Request field should be used to note the request type. The opcode field will likely state a TOR Timeout and may not be as useful.  The ADDR register contains the target physical address. It should be noted that the address field does not have byte granularity (lower 6 bits are not decoded). this will make exact access difficult, but we get into the right area. The process for this error is to isolate the Original request, core/thread id and address and to map them back via a system memory mapping function. This is normally taken from the system when it boots up again. \n\nThis decode is normally accompanied by an MLC (three strike timeout) machine check. The address logged in that bank will log the EIP value at the time of the three strike. The core id logged in the Cbo timeout MISC register should align with the core MLC machine check. In the case of multiple 'hits' this may be used to correlate multiple stuck transactions to the cores that allocated these transactions.",
             '检查CPU主板（CPU电源）环温'],
        13: ['Cbo Error - Internal Error', '', '重启观察'],
        14: ['Cbo Error - Internal Error', '', '重启观察'],
        15: ['Cbo Error - Internal Error', '', '重启观察'],
        17: ['Cbo Error - LLC_TAG_CORR_ERR', '', '重启观察'],
        18: ['Cbo Error - LLC_STATE_CORR_ERR', '', '重启观察'],
        19: ['Cbo Error - LLC_STATE_UNCORR_ERR', '', '重启观察'],
        20: ['Cbo Error - LLC_CV_CORR_ERR', '', '重启观察'],
        21: ['Cbo Error - LLC_CV_UNCORR_ERR', '', '重启观察'],
        22: ['Cbo Error - Internal Protocol Error', '', '重启观察'],
        23: ['Cbo Error - MSCOD_MULT_LLC_WAY_TAG_MATCH',
             'This code represents a multiple tag match in the LLC lookup. An error of this type is normally associated with a soft error. This type of error should be very rare. If the error is not rare, then possible paths for isolation are to look at a part specific issuer or platform power delivery to the part. In both cases they may be accompanied by other errors reported. If viral is enabled (EX), this error will trigger an event.',
             '检查CPU主板（CPU电源）环温'],
        24: ['Cbo Error - BL_REQ_RTID_TABLE_MISS', '', '重启观察'],
        25: ['Cbo Error - AK_REQ_RTID_TABLE_MISS', '', '重启观察'],
        28: ['Cbo Error - IDI_JITTER_ERROR', '', '重启观察'],
        29: ['Cbo Error - Internal Parity Error', '', '重启观察'],
        30: ['Cbo Error - Internal Parity Error', '', '重启观察'],
        31: ['Cbo Error - Internal Parity Error', '', '重启观察'],
        33: ['Cbo Error - UNCORRECTABLE_SnoopFilter_TAG_ERROR', '', '重启观察'],
        34: ['Cbo Error - SnoopFilter_TAG_CORR_ERR', '', '重启观察'],
        35: ['Cbo Error - SnoopFilter_STATE_CORR_ERR', '', '重启观察'],
        36: ['Cbo Error - SnoopFilter_STATE_UNCORR_ERR', '', '重启观察'],
        37: ['Cbo Error - SnoopFilter_CV_CORR_ERR', '', '重启观察'],
        38: ['Cbo Error - SnoopFilter_CV_UNCORR_ERR', '', '重启观察'],
        39: ['Cbo Error - SAD_ERR_LTMEMLOCK', '', '重启观察'],
        40: ['Cbo Error - LLC_TWOLM_CORR_ERR', '', '重启观察'],
        41: ['Cbo Error - LLC_TWOLM_UNCORR_ERR', '', '重启观察'],
        42: ['Cbo Error - ISMQ_UNEXP_RSP', '', '重启观察'],
        43: ['Cbo Error - TWOLM_MULT_HIT', '', '重启观察'],
        44: ['Cbo Error - HA_UNEXP_RSP', '', '重启观察'],
        45: ['Cbo Error - SAD_ERR_RRQWBQ_TO_NONHOM', '', '重启观察'],
        46: ['Cbo Error - SAD_ERR_IIOTONONHOM', '', '重启观察'],
    }},
    {'bankType': 'UPI', 'fieldMask': 0x00000000ffff0000, 'AndMask': 0x00000000ffff0000, 'OrMask': 0xffffffff0000ffff,
     'genDesc': 'UPI Errors',
     'decode': {
         0: ['Uncorrectable Phy Initialization Failure', '', ''],
         1: ['Uncorrectable Phy Detected Drift Buffer Alarm', '', ''],
         2: ['Uncorrectable Phy Detected Latency Buffer Rollover', '', ''],
         16: ['Uncorrectable LL Rx detected CRC error: unsuccessful LLR (entered Abort state)', '', ''],
         17: ['Uncorrectable LL Rx Unsupported/Undefined packet', '', ''],
         19: ['Uncorrectable LL Rx Parameter Exception', '', ''],
         31: ['Uncorrectable LL Detected Control Error from M3UPI', '', ''],
         32: ['Correctable Phy Initialization Abort', '', ''],
         33: ['Correctable Phy Reset', '', ''],
         34: ['Correctable Phy Lane failure, recovery in x8 width', '', ''],
         35: ['Correctable Phy L0c error corrected without Phy reset', '', ''],
         36: ['Correctable Phy L0c error triggering Phy Reset', '', ''],
         37: ['Correctable Phy L0p exit error triggering Phy Reset', '', ''],
         48: ['Correctable LL Rx detected CRC error: successful LLR without Phy Reinit', '', ''],
         49: ['Correctable LL Rx detected CRC error: successful LLR with Phy Reinit', '', '']
     }},
]

_mcRegs = {0: {"type": "core", "name": "IFU", "ctl": "ifu_mc0_ctl", "ctl2": None, "status": "ifu_mc0_status",
               "addr": "ifu_mc0_addr", "misc": "ifu_mc0_misc", "misc2": "ifu_mc0_misc2"},
           1: {"type": "core", "name": "DCU", "ctl": "dcu_mc1_ctl", "ctl2": None, "status": "dcu_mc1_status",
               "addr": "dcu_mc1_addr", "misc": "dcu_mc1_misc", "misc2": "dcu_mc1_misc2"},
           2: {"type": "core", "name": "DTLB", "ctl": "dcu_mc1_ctl", "ctl2": None, "status": "dtlb_mc2_status",
               "addr": "dcu_mc2_addr", "misc": "dcu_mc2_misc", "misc2": "dtlb_mc2_misc2"},
           3: {"type": "core", "name": "MLC", "ctl": "ml2_mc3_ctl", "ctl2": None, "status": "ml2_mc3_status",
               "addr": "ml2_mc3_addr", "misc": "ml2_mc3_misc", "misc2": "ml2_mc3_misc2"},
           4: {"type": "uncore", "name": "PCU", "ctl": "pcu_cr_mc_ctl", "ctl2": "pcu_cr_mc_ctl2",
               "status": "pcu_cr_mc_status", "addr": "pcu_cr_mc_addr", "misc": "pcu_cr_mc_misc", "misc2": None},
           5: {"type": "uncore", "name": "UPI0", "ctl": "kti0_mc_ctl", "ctl2": "kti0_mc_ctl2", "status": "kti0_mc_st",
               "addr": "kti0_mc_ad", "misc": "kti0_mc_misc", "misc2": None},
           6: {"type": "uncore", "name": "IIO", "ctl": "virtual_msr_iio_merge_mc_ctl",
               "ctl2": "virtual_msr_iio_merge_mc_ctl2", "status": "virtual_msr_iio_merge_mc_status",
               "addr": "virtual_msr_iio_merge_mc_addr", "misc": "virtual_msr_iio_merge_mc_misc", "misc2": None},
           7: {"type": "uncore", "name": "M2MEM0", "ctl": "imc0_m2mem_mci_ctl", "ctl2": "imc0_m2mem_mci_ctl2",
               "status": "imc0_m2mem_mci_status", "addr": "imc0_m2mem_mci_addr", "misc": "imc0_m2mem_mci_misc",
               "misc2": None},
           8: {"type": "uncore", "name": "M2MEM1", "ctl": "imc1_m2mem_mci_ctl", "ctl2": "imc1_m2mem_mci_ctl2",
               "status": "imc1_m2mem_mci_status", "addr": "imc1_m2mem_mci_addr", "misc": "imc1_m2mem_mci_misc",
               "misc2": None},
           9: {"type": "uncore", "name": "CBO0", "ctl": "virtual_msr_cbo_merge0_mc_ctl",
               "ctl2": "virtual_msr_cbo_merge0_mc_ctl2", "status": "virtual_msr_cbo_merge0_mc_status",
               "addr": "virtual_msr_cbo_merge0_mc_addr", "misc": "virtual_msr_cbo_merge0_mc_misc", "misc2": None},
           10: {"type": "uncore", "name": "CBO1", "ctl": "virtual_msr_cbo_merge1_mc_ctl",
                "ctl2": "virtual_msr_cbo_merge1_mc_ctl2", "status": "virtual_msr_cbo_merge1_mc_status",
                "addr": "virtual_msr_cbo_merge1_mc_addr", "misc": "virtual_msr_cbo_merge1_mc_misc", "misc2": None},
           11: {"type": "uncore", "name": "CBO2", "ctl": "virtual_msr_cbo_merge2_mc_ctl",
                "ctl2": "virtual_msr_cbo_merge2_mc_ctl2", "status": "virtual_msr_cbo_merge2_mc_status",
                "addr": "virtual_msr_cbo_merge2_mc_addr", "misc": "virtual_msr_cbo_merge2_mc_misc", "misc2": None},
           12: {"type": "uncore", "name": "UPI1", "ctl": "kti1_mc_ctl", "ctl2": "kti1_mc_ctl2", "status": "kti1_mc_st",
                "addr": "kti1_mc_ad", "misc": "kti1_mc_misc", "misc2": None},
           13: {"type": "uncore", "name": "iMC0 C0", "ctl": "imc0_c0_imc0_mc_ctl", "ctl2": "imc0_c0_imc0_mc_ctl2",
                "status": "imc0_c0_imc0_mc_status", "addr": "imc0_imc0_mc8_addr", "misc": "imc0_c0_imc0_mc_misc",
                "misc2": None},
           14: {"type": "uncore", "name": "iMC0 C1", "ctl": "imc0_c1_imc0_mc_ctl", "ctl2": "imc0_c1_imc0_mc_ctl2",
                "status": "imc0_c1_imc0_mc_status", "addr": "imc0_imc1_mc9_addr", "misc": "imc0_c1_imc0_mc_misc",
                "misc2": None},
           17: {"type": "uncore", "name": "iMC0 C2", "ctl": "imc0_c2_imc0_mc_ctl", "ctl2": "imc0_c2_imc0_mc_ctl2",
                "status": "imc0_c2_imc0_mc_status", "addr": "imc0_imc2_mca_addr", "misc": "imc0_c2_imc0_mc_misc",
                "misc2": None},
           15: {"type": "uncore", "name": "iMC1 C0", "ctl": "imc1_c0_imc0_mc_ctl", "ctl2": "imc1_c0_imc0_mc_ctl2",
                "status": "imc1_c0_imc0_mc_status", "addr": "imc1_imc0_mc8_addr", "misc": "imc1_c0_imc0_mc_misc",
                "misc2": None},
           16: {"type": "uncore", "name": "iMC1 C1", "ctl": "imc1_c1_imc0_mc_ctl", "ctl2": "imc1_c1_imc0_mc_ctl2",
                "status": "imc1_c1_imc0_mc_status", "addr": "imc1_imc1_mc9_addr", "misc": "imc1_c1_imc0_mc_misc",
                "misc2": None},
           18: {"type": "uncore", "name": "iMC1 C2", "ctl": "imc1_c2_imc0_mc_ctl", "ctl2": "imc1_c2_imc0_mc_ctl2",
                "status": "imc1_c2_imc0_mc_status", "addr": "imc1_imc2_mca_addr", "misc": "imc1_c2_imc0_mc_misc",
                "misc2": None},
           19: {"type": "uncore", "name": "UPI2", "ctl": "kti2_mc_ctl", "ctl2": "kti2_mc_ctl2", "status": "kti2_mc_st",
                "addr": "kti2_mc_ad", "misc": "kti2_mc_misc", "misc2": None}}

# Fields definition from each MISC Register

_misc_bank_def = {
    # For each bank, this is the notation required.
    # Orange fields should be described in this dictionary
    # BANK NAME: [Field Name, MSB, LSB]

    'IFU': [['ADDRESS_MODE ', 8, 6],
            ['IFU_ADDR_LSB0', 5, 0],
            ],

    'DCU': [['ADDRMODE  ', 8, 6],
            ['RECADDRLSB', 5, 0],
            ],

    'MLC': [['THREAD    ', 23, 23],
            ['WAY       ', 22, 20],
            ['SQID      ', 19, 16],
            ['OPCODE    ', 15, 9],
            ['ADDRMODE    ', 8, 6],
            ['RECADDRLSB  ', 5, 0],
            ],

    'PCU': [['CORRECTED_ERROR_COUNT', 24, 17],
            ['ERROR_ADDRESS        ', 16, 0],
            ],

    'UPI': [['CORRECTABLE_ERRORS', 63, 54],
            ['NEXT_ERROR        ', 53, 42],
            ['RX_LANE_REVERSAL  ', 40, 40],
            ['PHY_STATE         ', 39, 37],
            ['ILLEGAL_FLIT_FIELD', 36, 36],
            ['SYNDROME_OR_L0CBADLANES', 35, 20],
            ['FLIT_HDR           ', 19, 0],
            ],

    'IIO': [['UCR_BUS_LOG     ', 31, 24],
            ['UCR_DEVICE_LOG  ', 23, 19],
            ['UCR_FUNCTION_LOG', 18, 16],
            ['UCR_SEGMENT_LOG ', 15, 8],
            ],

    'M2MEM': [['MIRROR_FAILOVER', 63, 63],
              ['MIRROR_CORRECTED_ERROR', 62, 62],
              ['DATA_ERROR_CHUNK', 61, 60],
              ['MC_CMD_MIRR_FO', 59, 59],
              ['MC_CMD_MIRR_SEC', 58, 58],
              ['MC_CMD_MIRR_REGION', 57, 57],
              ['MC_CMD_CHNL', 51, 50],
              ['MC_CMD_MEM_REGION', 49, 46],
              ['MC_CMD_OPCODE', 45, 40],
              ['MC_CMD_VLD', 39, 39],
              ['SMI_AD', 38, 38],
              ['SMI_MSG_CLASS', 37, 35],
              ['SMI_OPCODE', 34, 31],
              ['TRK_ID', 29, 21],
              ['ERROR_TYPE', 20, 11],
              ['ADDR_MODE', 8, 6],
              ['ADDR_LSB', 5, 0],
              ],

    'CBO': [['TORFSM  ', 59, 54],
            ['ORIGREQ ', 53, 44],
            ['TORID   ', 43, 39],
            ['OPCODE  ', 38, 29],
            ['RETRY   ', 27, 27],
            ['WAY     ', 18, 14],
            ['VICP    ', 11, 11],
            ['ADDRMODE  ', 8, 6],
            ['ADDRLSB   ', 5, 0],
            ],

    'IMC': [  # DECODED EXTRA_ERR_INFO FIELD [63:9]
        ['Mode-1, second corr error valid', 63, 63],
        ['Mode-1, first corr error valid', 62, 62],
        ['Second Error Failing Rank', 55, 51],
        ['First Error Failing Rank', 50, 46],
        ['Second Error Bit Mask', 45, 30],
        ['First Error Bit Mask', 29, 14],
        ['WDB ID or second error device', 13, 9],

        ['ADDRMODE   ', 8, 6],
        ['REC_ERR_LSB', 5, 0],
    ],
}

# Decode OrigReq values from CBO registers
_cboTorOrigRequestDecode = {
    0x180: 'Request for Ownership',
    0x181: 'Code Read',
    0x182: 'Data Read',
    0x183: 'Set Monitor',
    0x186: 'Data Read',
    0x187: 'Partial Cacheline Read. Also used for PCIeCfgRd transaction',
    0x18C: 'Write Combine Invalidate Line',
    0x18D: 'Write Combine Invalidate Line',
    0x18E: 'Uncacheable Read',
    0x18F: 'Write Invalidate Line. Also used for PCIeCfgWr transaction',
    0x190: 'Prefetch - Request for Ownership',
    0x191: 'Prefetch Code',
    0x192: 'Prefetch Data',
    0x193: 'PCIe Request - Write invalidate line',
    0x194: 'PCIe Request - Write invalidate line',
    0x198: 'Cache Line Flush',
    0x9B: 'LLC Victim (either EWB to memory or Evict Cache-line)',  # Double check this value with Anil
    0x19C: 'PCIe Request - Invalid to Modify',
    0x19E: 'PCIe Request - Read Current',
    0x1C4: 'Write-back Modify to Invalid',
    0x1C5: 'Write-back Modify to Exclusive',
    0x1C8: 'Invalid to Modify Request',
    0x1E0: 'Special Cycle',
    0x1E1: 'PCIe Request - Direct Cache Access',
    0x1E4: 'PCIe Request - NonSnoop Read',
    0x1E5: 'PCIe Request - NonSnoop Read',
    0x1E6: 'PCIe Request - NonSnoop Read',
    0x1F3: 'Unlock',
    0x1F4: 'Interrupt Acknowledge',
    0x1F5: 'Port Out (CFC/CF8 type transaction',
    0x1F6: 'Floating Point Exception',
    0x1F8: 'End-of-level triggered Interrupt',
    0x1F9: 'Interrupt (logically addressed)',
    0x1FA: 'Interrupt (physically addressed)',
    0x1FB: 'Interrupt Priority Update',
    0x1FC: 'Port In (CFC/CF8 type transaction)',
    0x1FE: 'Split Lock',
    0x1FF: 'Lock',
    0x100: 'Snoop',
    0x101: 'Snoop',
    0x102: 'Snoop',
    0x104: 'Snoop',
    0x108: 'Snoop',
    0x10A: 'Snoop',
    0x10F: 'Prefetch Hint'}

#############################################################################
##Helper class for bit manipulation
# Usage:
# v = BitVector(0xdeadbeef)
# v[3:0]  to read bit 0 to 3, return 0xf here
# v[3:0]=0x4  to write 0x4 to bit 0 to 3, replace 0xf to 0x4 here.
#
import math


class BitVector:
    def __init__(self, val):
        self._val = val

    def __setslice__(self, highIndx, lowIndx, newVal):
        assert math.ceil(math.log(newVal) / math.log(2)) <= (highIndx - lowIndx + 1)

        # clear out bit slice
        clean_mask = (2 ** (highIndx + 1) - 1) ^ (2 ** (lowIndx) - 1)

        self._val = self._val ^ (self._val & clean_mask)
        # set new value
        self._val = self._val | (newVal << lowIndx)

    def __getslice__(self, highIndx, lowIndx):
        return (self._val >> lowIndx) & (2L ** (highIndx - lowIndx + 1) - 1)


################################################################################################
class _mcaBankInfo():
    def __init__(self):
        self.cpuid = 0
        self.bankNum = 0
        self.bankName = ""
        self.channel = ""
        self.sktNum = 0
        self.coreNum = 0
        self.ctl = 0
        self.ctl2 = 0
        self.addr = 0
        self.misc = 0
        self.misc2 = 0
        self.status = 0
        self.addr_shadow0 = 0
        self.addr_shadow1 = 0
        self.misc_shadow = 0
        self.status_shadow = 0
        self.outInfotitle = ""

#
# prototype decoder for mci_misc regs
# pass in bank num and reg value
#
def _decodeMCAMiscReg(bank, misc):
    """ Recover field definitions for the MISC register
        Requires dictionaries to be updated:
             _misc_bank_def => Field description for each of the MISC registers
             _mcRegs => MC Banks defined
             _cboTorOrigRequestDecode => Decoding for the ORIGREQ field from CBO register
    """
    vec_misc = BitVector(misc)
    bankName = _mcRegs[bank]['name']

    # Recovers bank group rather than bank specific
    for name in _misc_bank_def.keys():
        if name in bankName:
            bankName = name

    for field in _misc_bank_def[bankName]:
        # If clause added to look for ORIGREQ decode, from CBO MCE
        if bankName == 'CBO' and field[0] == 'ORIGREQ':
            if eval("vec_misc[field[1]:field[2]]") in _cboTorOrigRequestDecode.keys():
                print " [{0}:{1}] {2} = {3} => {4}".format(field[1], field[2], field[0],
                                                           hex(eval("vec_misc[field[1]:field[2]]")),
                                                           _cboTorOrigRequestDecode[
                                                               eval("vec_misc[field[1]:field[2]]")])
            else:
                print " [{0}:{1}] {2} = {3}".format(field[1], field[2], field[0],
                                                    hex(eval("vec_misc[field[1]:field[2]]")))
        else:
            print " [{0}:{1}] {2} = {3}".format(field[1], field[2], field[0], hex(eval("vec_misc[field[1]:field[2]]")))


def _decodeMCABank(error):
    """
    One Machine Check Error per bank is recorded. However each bank can have multiple error bits set.
    We shall consider each error bit set as an individual error and not a single error per bank.
    Corrected error count is printed separately

   """
    # Doing this initial status check specifically for HA case, where perhaps status was 0x0 but status_shadow was valid
    global chnstr
    vec_error_status = BitVector(error.status)
    if (vec_error_status[63:63] == 1) or (vec_error_status[59:59] == 1) or (vec_error_status[58:58] == 1):
        print
        print "#### SKL#" + error.outInfotitle.strip("\n") + "####"
        print "MC_STATUS = 0x%016X" % error.status
        if error.channel != "":
            chnstr = "CPU%d_" % error.cpuid + error.channel
        (miscv, addrv) = _decodeMCStatus_simple(error.status)
        print
        _MscodDebugAdvice(error.bankNum, error.status)
        print
        if miscv:
            print "MC_MISC  =  0x%016X" % error.misc
            _decodeMCAMiscReg(error.bankNum, error.misc)
            print
            if (_mcRegs[error.bankNum]["misc2"] != None):
                print "MC_MISC2 =  0x%016X" % error.misc2
        if addrv:
            print "MC_ADDR  =  0x%016X" % error.addr
    # else:
        # pass
        # print
        # print "#### SKL#" + error.outInfotitle.strip("\n") + "####"
        # print "MC_STATUS = 0x%016X" % error.status
        # print "Not a valide MC_STATUS reg(MC_STATUS[63]=0), skipping MCA decoding...."
    if error.status_shadow == 0:
        return
    vec_error_stataus_shadow = BitVector(error.status_shadow)
    if (error.bankNum == 7) or (error.bankNum == 8):
        print
        print
        print
        print "MC_STATUS_SHADOW = 0x%016X" % error.status_shadow
        (miscv, addrv) = _decodeMCStatus_simple(error.status_shadow)
        print
        if vec_error_stataus_shadow[63:63]:
            _MscodDebugAdvice(error.bankNum, error.status_shadow)
            print
        if miscv:
            print "MC_MISC_SHADOW = 0x%016X" % error.misc_shadow
            _decodeMCAMiscReg(error.bankNum, error.misc_shadow)
        if addrv:
            shadowAddr = (error.addr_shadow1 << 32) | error.addr_shadow0
            print "MC_ADDR_SHADOW = 0x%016X" % shadowAddr
    # print
    # print "More detailed MCA Decode feature to be added later..."
    # print


# End _decodeMCABank()


def _findNonZeroLSB(numBits, value):
    #
    bitPos = 0
    # if we get a zero there is no lsb, return 0
    if (value == 0 or numBits == 0):
        return 0
    else:
        while (bitPos < numBits):
            # if we shift and the lsb is a 1, we are done
            if ((value >> bitPos) & 1) == 1:
                return bitPos
            else:
                bitPos = bitPos + 1

    return bitPos


def _MscodDebugAdvice(bank, status):
    # vec_status = BitVector(status)
    # mscod = vec_status[31:16]
    # advisory_msg = ""
    # advisory_msg_bank = 0
    bankName = ''

    bankName = _mcRegs[bank]["name"]

    #
    # Loop through the decode list in the mca advice module
    # There are multiple pages for each bank type so there are two tiers
    # of this lookup process, the first is to find a match for bank type and then it is to see if
    # the mask matches (andMask, orMask)
    #
    for item in _decodeList:
        # Find match for bankName
        # if (item['bankType'] == bankName):  //changed by Yaco Xu.
        if (item['bankType'] in bankName):
            # print
            # we have a bankType match, load the masks and see if there is a match
            # do an 'and' or 'or' mask of the status bits (mscod and mcacod) and see if we have a match.
            # print 'bankName Match'
            # print 'Status =%x : AndMask = %x : OrMask = %x' % (status, item['AndMask'], item['OrMask'])
            # print 'AndTestValue = %x  : OrTestValue = %x' % ((item['AndMask'] & status ), ( item['OrMask'] | status ))
            # we only check the mcacod value masks match (lowest 16 bits)
            # if there are bits set (otherwise we only use mscod)
            if (item['AndMask'] & 0xffff == 0) or (item['OrMask'] & 0xffff == 0xffff):
                # we assume only one page (this one)
                # just extract the mscod value and check for a table entry.
                print '  MSCOD decode type title: %s' % (item['genDesc'])
                # look up debug advice in the table of this 'item'
                # print '  Debug Advice:'
                # apply andmask and shift right 16 bits to normalize mscod value
                # if we find a key match, we print out the title (offset 0)
                # and debug advice (offset 1)
                # we could optimize this and pass in the offsets from the advice module...
                decodeKey = (status & item['fieldMask']) >> _findNonZeroLSB(64, item['fieldMask'])
                if (decodeKey in item['decode'].keys()):
                    print '  MSCOD Title: %s' % (item['decode'][decodeKey][0])
                    msg = _textwrap.wrap(item['decode'][decodeKey][1], 120)
                    for line in range(len(msg)):
                        print "  %s" % msg[line]
                    print "\n  Result: %s" % (item['genDesc']).strip() + '#' + "%s" % (item['decode'][decodeKey][0])
                    # add by Yaco Xu,print advice.
                    if item['decode'][decodeKey][2] != 'NA' or item['decode'][decodeKey][2] != '':
                        print '  Debug Advice: %s , ' % (item['decode'][decodeKey][2]) + chnstr
                else:
                    print 'No Advice found for this offset'
            else:
                # do full 'paging' check, that is check for match with entire mask (includes mcacod field)
                if ((item['AndMask'] & status == item['AndMask']) and (item['OrMask'] | status == item['OrMask'])):
                    # we have a match
                    print '  MSCOD decode type title: %s' % (item['genDesc'])
                    # look up debug advice in the table of this 'item'
                    # print '  Debug Advice:'
                    # apply andmask and shift right 16 bits to normalize mscod value
                    # if we find a key match, we print out the title (offset 0)
                    # and debug advice (offset 1)
                    # we could optimize this and pass in the offsets from the advice module...
                    decodeKey = (status & item['fieldMask']) >> _findNonZeroLSB(64, item['fieldMask'])
                    if (decodeKey in item['decode'].keys()):
                        print '  MSCOD Title: %s' % (item['decode'][decodeKey][0])
                        msg = _textwrap.wrap(item['decode'][decodeKey][1], 90)
                        for line in range(len(msg)):
                            print "  %s" % msg[line]
                        # add by Yaco Xu,print advice.
                        if item['decode'][decodeKey][2] != 'NA' or item['decode'][decodeKey][2] != '':
                            print '  Debug Advice: %s' % (item['decode'][decodeKey][2])
                    else:
                        print 'No Advice found for this offset'


def _decodeMCStatus_simple(status):
    miscv = 0
    addrv = 0
    vec_status = BitVector(status)
    if vec_status[63:63]:
        print "  [63] Valid"
    else:
        print "  [63] Not valid"
    if vec_status[62:62]:
        print "  [62] Overflow"
    else:
        print "  [62] No overflow"
    if vec_status[61:61]:
        print "  [61] Uncorrected error"
    else:
        print "  [61] Corrected error"
    if vec_status[60:60]:
        print "  [60] Enabled in MC_CTL"
    else:
        print "  [60] Not enabled in MC_CTL"
    if vec_status[59:59]:
        print "  [59] MC_MISC is valid"
        miscv = 1
    else:
        print "  [59] MC_MISC is not valid"
    if vec_status[58:58]:
        print "  [58] MC_ADDR is valid"
        addrv = 1
    else:
        print "  [58] MC_ADDR is not valid"
    if vec_status[57:57]:
        print "  [57] Processor context corrupt"
    else:
        print "  [57] Processor context is NOT corrupt"

    if vec_status[61:61] and not vec_status[57:57]:
        vFlag = True
    else:
        vFlag = False

    vStr = " "
    if not vFlag:
        print "  [56] (Not valid since error was correctable or processor context is corrupt)"
    elif vec_status[56:56]:
        print "  [56] Signaled with MCERR %s" % vStr
    else:
        print "  [56] Signaled with CMCI %s" % vStr
    if not vFlag:
        print "  [55] (Not valid since error was correctable or processor context is corrupt)"
    elif vec_status[55:55]:
        print "  [55] Action required %s" % vStr
    else:
        print "  [55] No action required %s" % vStr

    if vec_status[54:53] == 1:
        print "  [54:53] Corrected Error Status = Green"
    elif vec_status[54:53] == 2:
        print "  [54:53] Corrected Error Status = Yellow"

    print "  [52:38] Corrected Error Count = %d" % vec_status[52:38]
    print "  [37:32] Other Info = 0x%02x" % vec_status[37:32]
    print "  [31:16] MSCOD = 0x%04x" % vec_status[31:16]
    print "  [15:0]  MCACOD = 0x%04x" % vec_status[15:0]
    return (miscv, addrv)


# End _decodeMCStatus_simple()


#########################################################
## Manual Decode block (get user inputs and decode them)
#########################################################
#
# ######################################################
# Name: getUserInput()
# Inputs:   None
# Output :  retList[] - True/False/'TestMode' (quit flag), bank, mcstatus, mcaddr, mcmisc
#

_menu = """
SKX Manual Machine Check Bank Decoder
Enter MCi_STATUS, MCi_ADDR, MCi_MISC values
RevString: %s
Enter 't' for a short demo
Enter 'Q' or 'q' to exit
""" % (_revString)


def _getUserInput():
    #
    # don't know how to return more than one item so we will pass a list
    retList = [False]
    reply = ''
    print _menu
    # Get Bank number
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCA Bank Name [0..31]:')
        if (reply == 'q' or reply == 'Q'):
            return (retList)
        # hook for test vector mode
        elif (reply == 't' or reply == 'T'):  # hook for test vector mode
            retList[0] = 'TestMode'
            return (retList)
        else:
            try:
                bank = int(reply)
                tryAgain = False
            except:
                print 'Incorrect number format, bank number is decimal only, please try again..'

    # Get MCi_STATUS
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_STATUS [0x0]: ')
        if (reply == 'q' or reply == 'Q'):
            return (retList)
        elif (reply == ''):
            mcstatus = 0
            tryAgain = False
        else:
            try:
                mcstatus = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'
    #
    # Get MCi_ADDR
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_ADDR   [0x0]: ')
        if (reply == 'q' or reply == 'Q'):
            return (retList)
        elif (reply == ''):
            mcaddr = 0
            tryAgain = False
        else:
            try:
                mcaddr = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'

    # Get MCi_MISC
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_MISC   [0x0]: ')
        if (reply == 'q' or reply == 'Q'):
            return (retList)
        elif (reply == ''):
            mcmisc = 0
            tryAgain = False
        else:
            try:
                mcmisc = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'

    # spacer for the output strings later
    print '\n\n'

    retList = [True, bank, mcstatus, mcaddr, mcmisc]
    return (retList)


#
#  Decode code is below
#
#
# ##########
# Name: bits()
#
# TODO : Remove if not used...
#
# The usual helper bits() function from ITP, returns a subset of the input register
# vector ased on the bit position and number of bits to return.
#
# def bits(inReg, bitPos, numBits):
# bitMask = (2 ** numBits) -1
# return ((inReg >> bitPos) & bitMask)


def _testVectors():
    print '\n\n***********************************************************************'
    print '\t\t\tTest Vectors \n'
    print '***********************************************************************\n'

    # MC1
    # bankNum   = 17
    # statusReg = 0xbe200000000c110a
    # miscReg   = 0xb0fff8160c400086
    # misc2Reg  = 0x0
    # addrReg   = 0x280
    # print 'basic first cut...'
    # ivtErrDump._decodeMCStatus_simple(statusReg)
    # ivtErrDump._MscodDebugAdvice(bankNum,statusReg)
    # print


    # define an mcabank object
    error = _mcaBankInfo()
    error.bankNum = 9
    error.bankName = 'CBO'
    error.status = 0xbe200000000c110a
    error.misc = 0xb0fff8160c400086
    error.misc2 = 0x0
    error.addr = 0x280
    # stuff object into decoder
    _decodeMCABank(error)

    # define an mcabank object - this from mca on crb
    error = _mcaBankInfo()
    error.bankNum = 9
    error.bankName = 'CBO'
    error.status = 0xBE200000000C110A
    error.misc = 0x70FC381600402086
    error.misc2 = 0x0
    error.addr = 0x0000000080500000
    # stuff object into decoder
    _decodeMCABank(error)


#
# This is the module entry point...
#
def manualDecode():
    """
    Decodes an MCA error and prints debug advice.

    Inputs:
    
        MCA Bank Name [0..31]
        MCi_Status value
        MCi_ADDR value
        MCi_MISC value
        
        
    Output:
    
        Decoded MCA registers, and debug advice (if available)
    
    
    Example Usage: Decode an MCA Bank 5 (QPI0) Error
    
    
        Enter MCA Bank Name [0..31]: 5
        Enter MCi_STATUS [0x0]: 0xC800014000310E0F
        Enter MCi_ADDR   [0x0]: 0x0
        Enter MCi_MISC   [0x0]: 0x001DF87B000D9EFF
        
        
        MC_STATUS = 0xC800014000310E0F
          [63] Valid
          [62] Overflow
          [61] Corrected error
          [60] Not enabled in MC_CTL
          [59] MC_MISC is valid
          [58] MC_ADDR is not valid
          [57] Processor context is NOT corrupt
          [56] (Not valid since error was correctable or processor context is corrupt)
          [55] (Not valid since error was correctable or processor context is corrupt)
          [52:38] Corrected Error Count = 5
          [37:32] Other Info = 0x00
          [31:16] MSCOD = 0x0031
          [15:0]  MCACOD = 0x0e0f

          MSCOD decode type title: QPI Errors
          MSCOD Title: QPI Error - Correctable: Tx CRC Error
          QPI Tx received a link level retry. This error is normally recommend to be disabled as it
          is a side effect of Rx CRC error on the other end of the QPI link. This is considered a
          temporary soft error type of event.

        MC_MISC  = 0x001DF87B000D9EFF
          [63:53] NERR               = 0x0
          [52:52] FLIT_VALID         = 0x1
          [51:32] FLIT_19_0          = 0xdf87b
          [25:25] LLQUIESCE          = 0x0
          [24:24] GVRETRY            = 0x0
          [23:23] PHYRESET           = 0x0
          [21:21] EARLY_INJECT_ERR   = 0x0
          [20:20] FLIT_L_STATE       = 0x0
          [19:15] FLIT_39_35         = 0x1b
          [14:6]  FLIT_28_20         = 0x7b
          [5:5]   FLIT_58            = 0x1
          [4:3]   FLIT_41_40         = 0x3
          [2:1]   FLIT_61_60         = 0x3
          [0:0]   IIB                = 0x1

    """

    try:
        #
        keepGoing = True
        bank = 0
        statusReg = 0
        addressReg = 0
        miscReg = 0
        #
        # KeegGoing (get input/process input)
        # until user wants to quit
        while keepGoing:
            retList = _getUserInput()
            if (retList[0] == 'TestMode'):
                _testVectors()
                keepGoing = False
            else:
                keepGoing = retList[0]
            #
            # We got inputs, fill in the
            # data structure and feed it to
            # the decoder module
            # This is done via manipulating a global list of errors
            #   1) append to the list (same as the dump logic would)
            #   2) call the decoder directly to work on the global
            #
            if (keepGoing == True):
                # define an mcabank object
                error = _mcaBankInfo()
                error.bankNum = retList[1]
                error.status = retList[2]
                error.misc = retList[4]
                error.addr = retList[3]
                # stuff object into decoder
                _decodeMCABank(error)

    except:
        import traceback
        log = open('mca_decode.log', 'w')
        traceback.print_exc()
        traceback.print_exc(file=log)
        log.close()


def main():
    if len(sys.argv) == 1:  # run without any arguments
        manualDecode()
        return

    if len(sys.argv) != 5:  # provide all 4 parameters
        print "Usage: mcd.py bank_num MCi_STATUS MCi_ADD MCi_MISC"
        sys.exit(2)

    # start the decoding
    error = _mcaBankInfo()
    error.bankNum = long(sys.argv[1], 16)
    error.status = long(sys.argv[2], 16)
    error.misc = long(sys.argv[4], 16)
    error.addr = long(sys.argv[3], 16)
    # stuff object into decoder
    _decodeMCABank(error)


if __name__ == "__main__":
    main()
