
#INTERNAL USE SOFTWARE LICENSE AGREEMENT 

#THIS INTERNAL USE SOFTWARE LICENSE AGREEMENT ("AGREEMENT") GOVERNS YOUR
#("YOUR" OR "YOU") USE OF THE ACCOMPANYING SOFTWARE ("SOFTWARE") AND ALL
#DOCUMENTS RELATED TO THE SOFTWARE ("DOCUMENTATION").  BY INSTALLING OR 
#COPYING ALL OR ANY PART OF THE SOFTWARE COMPONENTS IN THIS PACKAGE, YOU 
#AGREE TO THE TERMS AND CONDITIONS OF THIS AGREEMENT.  IF YOU DO NOT AGREE 
#TO THE TERMS AND CONDITIONS OF THIS AGREEMENT, PROMPTLY RETURN THE SOFTWARE 
#TO INTEL CORPORATION ("INTEL"). IF YOU ARE AN AGENT OR EMPLOYEE OF A LEGAL 
#ENTITY, YOU REPRESENT AND WARRANT THAT YOU HAVE THE AUTHORITY TO BIND SUCH 
#LEGAL ENTITY TO THIS AGREEMENT AND THE TERMS "YOUR" AND "YOU" IN THIS 
#AGREEMENT THEN WILL REFER TO THAT LEGAL ENTITY. 


#1.		LICENSE GRANTS AND RESTRICTIONS. 

#	1.1 Software License.  
#		Subject to the terms and conditions of this Agreement, Intel grants 
#		You a personal, non-transferable, non-exclusive, worldwide, 
#		non-sublicensable limited right and license: 

#	(A) under Intel's copyrights to:

#	(1)		reproduce all or any portion of the Software solely for Your 
#			internal use for the sole purpose of performing validation 
#			activities on Your computer systems that use Intel 
#			microprocessors as the central processor; provided, however, 
#			that this license may be exercised only by Your employees and 
#			only within Your facilities; 

#	(2)		prepare derivative works of the Software for the sole purpose of 
#			performing validation activities on Your computer systems that 
#			use Intel microprocessors as the central processor; provided, 
#			however, that this license may be exercised only by Your 
#			and only within Your facilities; 

#	(3)		copy the Documentation as is reasonably necessary for You to 
#			exercise Your rights under this Section 1.1; and 

#	(B)	under Intel's Licensed Patent Claims to make copies of the Software 
#		and use the Software solely in connection with the license rights 
#		granted to You under Section 1.1, only within Your facilities and 
#		only by Your employees; provided, however, that the license under the 
#		Licensed Patent Claims does not and will not apply to any 
#		modifications to, or derivative works of, the Software, whether made 
#		by You or any third party even if the modifications and derivative 
#		works are permitted under Section 1.1.  "Licensed Patent Claims" 
#		means the claims of Intel's patents that are necessarily and directly 
#		infringed by the reproduction of the Software that is authorized in 
#		Section 1.1(A), when that Software is in its unmodified form as 
#		delivered by Intel to You and not modified or combined with anything 
#		else.  Licensed Patent Claims are only those claims that Intel can 
#		license without paying, or getting the consent of, a third party. 

#1.2	Limitations.  

#	(A)	Unless expressly permitted under Section 1.1, or unless You obtain 
#		Intel's prior express written permission, You will not and will not 
#		allow any third party to: 

#		(1)		use or copy the Software; 

#		(2)		modify, adapt, enhance, disassemble, decompile, reverse 
#				engineer, change or create derivative works from the 
#				Software; or 

#		(3)		use the Software to process the date of, or make the Software 
#				available online for the use of, third parties. 

#	(B)	The consideration under this Agreement is only for the licenses that 
#		Intel expressly grants to You in Section 1.1.  Any other rights 
#		including, but not limited to, additional patent rights, will 
#		require an additional license and additional consideration.  
#		Nothing in this Agreement requires or will be treated to require 
#		Intel to grant any additional license.  You acknowledge that an 
#		essential basis of the bargain in this Agreement is that Intel 
#		grants you no licenses or other rights including, but not limited 
#		to, patent, copyright, trademark, trade name, service mark or other 
#		intellectual property licenses or rights with respect to the Software 
#		and Documentation, by implication, estoppel or otherwise, except for 
#		the licenses expressly granted in Section 1.1.  Specifically, except 
#		for the licenses expressly granted to You in Section 1.1, Intel 
#		grants no licenses or other rights, expressly or by implication, 
#		estoppel or otherwise, to: 

#		(1)	make, use, sell, offer for sale, or import modifications of the 
#			Software; 
#		(2)	sell or offer to sell the Software; 
#		(3)	combine the Software or modified versions of the Software with 
#			other items or to use any such combination; or 
#		(4)	any claims of any patents, patent applications, or other patent 
#			rights of Intel other than the Licensed Patent Claims.  

#	(C)	You acknowledge that there are significant uses of the Software in 
#		its original, unmodified and uncombined form.  The consideration for 
#		the license in this Agreement reflects Intel's continuing right to 
#		assert patent claims against any modifications or derivative works 
#		(including without limitation, error corrections and bug fixes) of, 
#		or combinations with, the Software that You or third parties make 
#		that infringe any Intel patent claim.  

#	(D)	Except as expressly permitted under Section 1.1, You will not allow 
#		the Software or Documentation to be accessed or used by third parties 
#		or anyone other than Your employees whose duties require access or use.

#2.		OPEN SOURCE SOFTWARE.  The Software includes Open Source Software that 
#		is licensed under the applicable Open Source Software license 
#		agreement identified in the Open Source Software comments in the 
#		applicable Source Code file(s) and File Header provided with the 
#		Software.  Where applicable, the Documentation may contain additional 
#		detail.  With respect to the Open Source Software, nothing in this 
#		Agreement limits any rights under, or grants rights that supersede, 
#		the terms of the applicable Open Source Software license agreement.  
#		You will not subject the Software or Documentation, in whole or in 
#		part, to any license obligations associated with Open Source Software 
#		in a manner that subjects Intel, or any portion of the Software, to any 
#		license obligations of the Open Source Software.  

#3.		OWNERSHIP.

#	3.1		Software and Documentation.  All rights, title and interest in 
#			and to the Software and Documentation, including all copies 
#			thereof, are and will remain the exclusive property of Intel or 
#			its suppliers or licensors.  The Software is copyrighted and 
#			protected by the laws of the United States and other countries, 
#			and international treaty provisions. You may not remove any 
#			copyright notices from the Software.

#	3.2		Derivative Works.  Intel will own all copyrights in derivative 
#			works.  You irrevocably transfer and assign to Intel in 
#			perpetuity all worldwide copyrights (including, but not 
#			limited to, applications for registration of those rights and 
#			all priority rights under applicable international conventions 
#			for the protection of those rights) in the derivative works that 
#			You may have, as and when those rights arise.  You will maintain 
#			and protect Intel's copyrights in the derivative works including, 
#			but not limited to, executing any documents that Intel reasonably 
#			considers necessary for that purpose.  Intel will have the sole 
#			and unlimited right to reproduce, publish and display the 
#			derivative works, in whole or in part, or combine the 
#			derivative works with other matter or not use the derivative 
#			works at all. 

#	3.3		Feedback.  To the extent You provide Intel with Feedback, You 
#			grant to Intel and Intel accepts, a worldwide, non-exclusive, 
#			perpetual, irrevocable, royalty-free, transferable license, 
#			with the right to sublicense, under Your intellectual property 
#			rights to the Feedback to incorporate or otherwise use Feedback 
#			as provided by You to Intel.  "Feedback" means Your requirements, 
#			inputs, comments, responses, opinions, feedback and errata, 
#			whether oral or written, concerning the Software and 
#			Documentation and Your technical system requirements for Intel to 
#			include in the Software definition, design or validation.  This 
#			Section 3.3 will survive any termination of this Agreement.

#4.		CONFIDENTIALITY.  The Software and Documentation contain confidential and 
#		proprietary information of Intel and, together with the terms and 
#		conditions of this Agreement and any other confidential information 
#		disclosed in the course of performance of this Agreement, are subject to 
#		the applicable Corporate Non-Disclosure Agreement between You and Intel (
#		"CNDA"), or such other non-disclosure agreement as may be agreed to by 
#		the parties.  

#5.		NO SUPPORT.  Intel has no obligation to maintain or support the Software 
#		or Documentation.  

#6.		DISCLAIMER OF WARRANTY.  The Software is provided "AS IS" with no 
#		warranties of any kind, whether written, oral, implied or statutory, 
#		including warranties of merchantability or fitness for a particular 
#		purpose, non-infringement or arising from course of dealing or usage in 
#		trade.   

#7.		LIMITATION OF LIABILITY.  Intel and its suppliers shall not be liable for 
#		any property damage, personal injury, loss of profits, loss of use, 
#		interruption of business, or for any other special, consequential, 
#		punitive or incidental damages, however caused, whether for breach of 
#		warranty, contract, tort, negligence, strict liability or otherwise, 
#		irrespective of whether Intel has advance notice of the possibility of 
#		such damages.  

#8.		TERMINATION.  Intel may terminate this Agreement, including the licenses 
#		granted in Section 1.1, at any time upon notice to You.  Upon 
#		termination, You will immediately destroy the Software or return all 
#		copies of the Software to Intel along with any copies You have made.  You 
#		may terminate this Agreement at any time upon notice to Intel and 
#		destroying the Software, or returning the Software to Intel.  

#9.		ASSIGNMENT.  Except as expressly permitted under Section 1.1, You may not:
#		(A) delegate, assign or transfer this Agreement, or any of Your rights 
#		and obligations under this Agreement, or (B) sublicense, assign or 
#		transfer all or any part of the Software, Documentation or Confidential 
#		Information, to any third party temporarily (such as loaning, rental, 
#		licensing or timeshare) or permanently, whether by contract, operation of 
#		law, acquisition, merger, consolidation, sale of all or substantially all 
#		of Your outstanding shares or assets, other changes in control, or any 
#		other event, without the prior written consent of Intel in each instance, 
#		which consent Intel may withhold in its sole discretion.  Any attempted 
#		assignment, transfer, or sublicense that is not expressly permitted under 
#		Section 1.1 or is without consent will be a material breach of this 
#		Agreement and will be null and void.  Subject to the provisions of this 
#		Section, this Agreement will bind and inure to the benefit of the parties 
#		and their permitted successors and assigns.  

#10.	U.S. GOVERNMENT RIGHTS.  The technical data and computer software 
#		covered by this Agreement is a "Commercial Item," as such term is 
#		defined by the FAR 2.101 (48 C.F.R. 2.101) and is "commercial 
#		computer software" and "commercial computer software documentation" 
#		as specified under FAR 12.212 (48 C.F.R. 12.212) or DFARS 227.7202 
#		(48 C.F.R. 227.7202), as applicable.  This commercial computer 
#		software and related documentation is provided to end users for use, 
#		by and on behalf of the U.S. Government, with only those rights as 
#		are granted to all other end users pursuant to the terms and 
#		conditions herein.  Use for or on behalf of the U.S. Government is 
#		permitted only if the party acquiring or using this software is 
#		properly authorized by an appropriate U.S. Government official.  This 
#		use by or for the U.S. Government clause is in lieu of, and 
#		supersedes, any other FAR, DFARS, or other provision that addresses 
#		Government rights in the Software covered by this Agreement.

#11.	EXPORT LAWS.  You will not export, either directly or indirectly, 
#		any product, service or technical data or system incorporating the 
#		Software without first obtaining any required license or other 
#		approval from the U. S. Department of Commerce or any other agency or 
#		department of the United States Government.  In the event any product 
#		is exported from the United States or re-exported from a foreign 
#		destination by You, You shall ensure that the distribution and 
#		export/re-export or import of the product is in compliance with all 
#		laws, regulations, orders, or other restrictions of the U.S. Export 
#		Administration Regulations and the appropriate foreign government.  
#		You agree that neither You nor any of Your subsidiaries will 
#		export/re-export any technical data, process, product, or service, 
#		directly or indirectly, to any country for which the United States 
#		government or any agency thereof or the foreign government from where 
#		it is shipping requires an export license, or other governmental 
#		approval, without first obtaining such license or approval.

#12.	GOVERNING LAW.  All disputes arising out of or related to this 
#		Agreement, whether based on contract, tort, or any other legal or 
#		equitable theory, will in all respects be governed by, and construed 
#		and interpreted under, the laws of the United States of America and 
#		the State of Delaware, without reference to conflicts of laws 
#		principles.  The parties agree that the United Nations Convention on 
#		Contracts for the International Sale of Goods (1980) is specifically 
#		excluded from and will not apply to this Agreement. 

#13.	ENTIRE AGREEMENT.  This Agreement contains the complete and exclusive 
#		agreement and understanding between the parties concerning the 
#		subject matter of this Agreement, and supersedes all prior and 
#		contemporaneous proposals, agreements, understandings, negotiations, 
#		representations, warranties, conditions, and communications, oral or 
#		written, between the parties relating to the subject matter.  This 
#		Agreement, including without limitation, its termination, has no 
#		effect on any signed non-disclosure agreements between the parties, 
#		which remain in full force and effect as separate agreements 
#		according to their terms.  No modification or amendment to this 
#		Agreement will be effective unless in writing and signed by 
#		authorized representatives of each party.  


#Copyright C 2012-2013, Intel Corporation  

#!/usr/bin/env python
"""
    Module: mcd_ivt.py

    Package Dependency: None
    Description: 
        This is a standalone MCA(Machine Check Architecture) decoder for Ivytown processor.
        Users could run the script as 1) manual decoding; or 2) pass in command line parameters.
        Please see the usage instruction document in the same script folder.

    Autor: Jerr Chen
    Date: September 6, 2014
"""

import textwrap as _textwrap
import sys


#
# Define the mc banks and registers inside each bank. There are three big skus of IVT [EX, EP, EN]. These impact what is in the socket and this in turn impacts how many
# valid mca banks are there. The good news is the map is the same and what occurs is that as we vary sku, more or less banks are reserved or propulated but the overall mapping stays the same
# this means we can have one mapping (below) and can just manage lists of valid banks for each sku. Later in the code, we do a sku check and figure out how we loop through
# the various banks.
#
# On the EX sku, one important note is that we end up with 34 (yes) banks. So besides the 32
# architected banks, there are two alias banks (4,5). This means that 4 is normally the pcu and 5 is normally qpi0. If there are
# errors in qpi1 bank 4 will log it and if there are errors in qpi2, bank 5 will log it. The two registers actually live in
# another msr address range. These two banks are listed in this code as bank 32 and 33 (they are not called out this way in the eds.
# When there is an error in 4 or 5 later we must check 32 and 33 for 'hits' to see what type we are dealing with
#
# IVT has no IIO mca bank (6) but the bank is still reserved.
#
#
_revString = '2014.09.10 - Ivytown' 
_decodeList = [
{'bankType':'IFU', 'fieldMask':0x00000000000f0000,'AndMask':0x0000000000000005,'OrMask':0xffffffffffff0005,'genDesc':'IFU Internal Parity Error','decode':{0: ['Register File Parity Error ', 'Register file buffer reported machine check. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivies to voltage, frequency and temperature. In a properly functioning part an effort of this kind can manifest itself by operating the part out of specified tolerances. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. In the non compounded case, this error is expected to assert the MCERR# variant of the error. '], 1: ['DSB Parity Errors', 'Data sequencer buffer parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivies to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. In the non compounded case, this error is expected to assert the MCERR# variant of the error. '], 2: ['MS uRAM Parity Error', 'Micro sequencer uRam parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivies to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.  In the non compounded case, this error is expected to assert the MCERR# variant of the error. '], 3: ['Instruction Queue Parity Error ', 'Instruction queue parity error. Errors of this type can be silicon related (we may see this on earlier steppings of parts) but are generally not expected in production stages of the development cycle.  Steps should be taken to isolate the failure to a specific part. Test for sensitivies to voltage, frequency and temperature. The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.  In the non compounded case, this error is expected to assert the MCERR# variant of the error. '], 4: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 5: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 6: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 7: ['Instruction Decode Queue Parity Error  ', ''], 8: ['Branch Array Parity Error   ', ''], 9: ['MS Unique ROM Parity Error', ''], 10: ['MS Pointer ROM Parity Hard Error', ''], 11: ['MS Pointer ROM Parity Recoverable Error', ''], 12: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 13: ['Undefined Encoding', 'Undefined encoding'], 14: ['Undefined Encoding', 'Undefined encoding'], 15: ['Inclusion Error', 'Operation violates the inclusion property of the cache structures.  The requested instruction is no longer in the cache domain (which is what the inclusion property implies).  An error of this type is likely core voltage related or a specific part failure. ']}},
{'bankType':'IFU', 'fieldMask':0x00000000000f0000,'AndMask':0x0000000000000100,'OrMask':0xffffffffffff01f0,'genDesc':'IFU Parity Error    ','decode':{0: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 1: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 4: ['ICache Data Parity Error ', 'Poison signature in the IFU. This implies the data received by the IFU was inverted as part of a poison event. The origin of the error is elsewhere.  Check for poison forwarding mode and other MCA Status banks. In a poison enabled failure case, the source of the error should have logged a corrected error. This implies that the MCA bank logs may not be sufficient given there is a time element to this. The originating failure will have been logged and signaled via CMCI. The operating system should contain logs of this source stream.   The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins.'], 5: ['ICache Tag Parity Error', 'Icache tag parity error. This type of error should be a very rare event under normal operating conditions.   If this error is repeatable in any domain, it is likely a core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.'], 6: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 7: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 8: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 9: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 10: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 11: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 12: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 13: ['Undefined Encoding', 'Undefined encoding'], 14: ['Undefined Encoding', 'Undefined encoding'], 15: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod']}},
{'bankType':'IFU', 'fieldMask':0x00000000000f0000,'AndMask':0x0000000000000010,'OrMask':0xffffffffffff0010,'genDesc':'ITLB Parity Error   ','decode':{0: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 1: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 4: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 5: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 6: ['ITLB Linear or Physical Parity Errors', 'ITLB parity error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 7: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 8: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 9: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 10: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 11: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 12: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 13: ['Undefined Encoding', 'Undefined encoding'], 14: ['Undefined Encoding', 'Undefined encoding'], 15: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod']}},
{'bankType':'IFU', 'fieldMask':0x00000000000f0000,'AndMask':0x0000000000000406,'OrMask':0xffffffffffff0406,'genDesc':'Internal Control Flow Errors','decode':{0: ['Ucode Trusted Paths Error', 'Microcode control flow error'], 1: ['Undefined Encoding', ''], 2: ['Patch RAM Protection Trusted Paths Error', 'Microcode updage control flow error'], 3: ['Undefined Encoding ', ''], 4: ['C6 SRAM Protection Trusted Paths Error', 'Illegal access error'], 5: ['Undefined Encoding', '']}},
{'bankType':'DCU', 'fieldMask':0x0000000000200000,'AndMask':0x0000000000200401,'OrMask':0xffffffffff200401,'genDesc':'DCU APIC Error      ','decode':{0: ['Reserved', 'Reserved Encoding'], 1: ['APIC Error', 'An error was detected and the address range was in the APIC region. A common error of this type is related to incorrect cachebility type for the APIC region. Check to see the mapping of the APIC region is correct (uncacheable).']}},
{'bankType':'DCU', 'fieldMask':0x0000000000200000,'AndMask':0x0000000000000104,'OrMask':0xffffffffffef01f4,'genDesc':'DCU Parity Error    ','decode':{0: ['DCU Parity Error', '?'], 1: ['APIC Error', 'An error was detected and the address range was in the APIC region. A common error of this type is related to incorrect cachebility type for the APIC region. Check to see the mapping of the APIC region is correct (uncacheable).']}},
{'bankType':'DCU', 'fieldMask':0x0000000000100000,'AndMask':0x0000000000100174,'OrMask':0xffffffffff100174,'genDesc':'DCU Parity Error    ','decode':{0: ['Reserved', 'Reserved Encoding'], 1: ['WBINVD Error', 'This error code represents a data error WBINV cycle. This is not a software generated event.  The error is uncorrectable but in some cases the escalation may (poison enabled) be deferred or delayed. In any event, the cause of the failure is likely to be related to power delivery to the cores. The implication is that this error can appear as an MCE or as a CMCI event. One can check for the condition based on the UC, PCC, S and AR bits of MCi_STATUS to understand which variant of the error escalation flow this is logged in.']}},
{'bankType':'DCU', 'fieldMask':0x0000000000100000,'AndMask':0x0000000000100134,'OrMask':0xffffffffff100134,'genDesc':'DCU Parity Error    ','decode':{0: ['Reserved', 'Reserved Encoding'], 1: ['Poison Error', 'An uncorrected error has been detected on a DCU cycle (see MCACOD bits for transaction type). This is uncorrected. This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].']}},
{'bankType':'DTLB', 'fieldMask':0x0000000000070000,'AndMask':0x0000000000000005,'OrMask':0xffffffffffff0005,'genDesc':'Internal Parity Error','decode':{0: ['Reserved', ''], 1: ['Reserved', ''], 2: ['Internal Reg File Parity Error', ''], 3: ['Reserved', ''], 4: ['Internal Reg File Parity Error', ''], 5: ['Reserved', '']}},
{'bankType':'DTLB', 'fieldMask':0x0000000000030000,'AndMask':0x0000000000000010,'OrMask':0xffffffffffff001c,'genDesc':'DTLB Parity Error   ','decode':{0: ['DTLB Tag Parity Error', ''], 1: ['DTLB Data Parity Error', ''], 2: ['PDE Tag Parity Error', ''], 3: ['PDE Data Parity Error', '']}},
{'bankType':'DTLB', 'fieldMask':0x0000000000030000,'AndMask':0x0000000000000011,'OrMask':0xffffffffffff001d,'genDesc':'STLB Parity Error   ','decode':{0: ['STLB Tag Parity Error', ''], 1: ['STLB Data Parity Error', ''], 2: ['PDE Tag Parity Error', ''], 3: ['PDE Data Parity Error', '']}},
{'bankType':'DTLB', 'fieldMask':0x0000000000030000,'AndMask':0x0000000000000012,'OrMask':0xffffffffffff001f,'genDesc':'TLB Parity Error','decode':{0: ['TLB Tag Parity Error', ''], 1: ['TLB Data Parity Error', ''], 2: ['PDE Tag Parity Error', ''], 3: ['PDE Data Parity Error', '']}},
{'bankType':'DTLB', 'fieldMask':0x00000000000f0000,'AndMask':0x0000000000000406,'OrMask':0xffffffffffff0406,'genDesc':'Internal Control Flow Errors','decode':{0: ['Reserved', ''], 1: ['Reserved', ''], 2: ['Reserved', ''], 3: ['Internal Control Flow Error', ''], 4: ['Internal Control Flow Error', ''], 5: ['Reserved', '']}},
{'bankType':'MLC', 'fieldMask':0x0000000000800000,'AndMask':0x0000000000000400,'OrMask':0xffffffffffff0400,'genDesc':'Internal Error      ','decode':{0: ['No Error', ''], 1: ['Watchdog Timer (3-strike) Error', 'No core uops retired within the watchdog  timeout value. This value is nominally set to 21.47 seconds. This is not necessarily indicative of a CPU issue. The most common cause of this issue is a non-completion of a transaction by an external agent. The basic debug of this type of issue is to isolate this outstanding transaction. If the crashdump process is enabled for this platform, use the data for further fault isolation. The crashdump will extract outstanding transactions from the LLC ( Cbo TOR - Cbox Table of Requests). One of these is likely to be the source of the timeout condition.  Pay particular attention to the core id (not the same as APIC ID but can be derived) of this MCA bank and correlate it to the core id of the Cbo TOR array entries. There may be other side effect entries in the TOR, these could be disregarded.  This process will yield a starting point. The next step is to understand why this outstanding transaction has not been completed. One normally has to extract a system memory map from the failing UUT in order to isolate where in the system the address was targeted towards. This would be the basis of the next stage of the debug.']}},
{'bankType':'MLC', 'fieldMask':0x0000000000400000,'AndMask':0x0000000000000400,'OrMask':0xffffffffffff0407,'genDesc':'Internal Error      ','decode':{0: ['No Error', ''], 1: ['Internal Queue Parity Error', ''], 2: ['Reserved', '']}},
{'bankType':'MLC', 'fieldMask':0x0000000000300000,'AndMask':0x0000000000000101,'OrMask':0xffffffffffff11fd,'genDesc':'MLC Error           ','decode':{0: ['MLC Data No Error', ''], 1: ['MLC Data Single Error', 'MLC Data Read corrected error.  The MLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).'], 2: ['MLC Data Double Error', 'MLC Data Read error.  This is an uncorrected error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance]. If this error is coupled with previous failure data (a long succession of single bit errors with a TES state changing to Yellow), then it may be a sign of a part degrading.'], 3: ['Reserved', '']}},
{'bankType':'MLC', 'fieldMask':0x00000000000c0000,'AndMask':0x0000000000000101,'OrMask':0xffffffffffff11fd,'genDesc':'MLC Error           ','decode':{0: ['MLC MESI No Error', ''], 1: ['MLC MESI Corrected Error', 'MLC single bit corrected error in MESI state structure. The MLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).'], 2: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod'], 3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod']}},
{'bankType':'MLC', 'fieldMask':0x0000000000030000,'AndMask':0x0000000000000101,'OrMask':0xffffffffffff11fd,'genDesc':'MLC Error           ','decode':{0: ['MLC Tag No Error', ''], 1: ['MLC Tag Single Error', 'The MLC structure has detected a tag parity error (single bit error, uncorrected).   Failures of this type are very rare events under normal operating conditions.   If this error is repeatable in any domain, it is likely a core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.'], 2: ['MLC Tag Double Error', 'The MLC structure has detected a tag parity error (double bit error, uncorrected).   Failures of this type are very rare events under normal operating conditions.   If this error is repeatable in any domain, it is likely a core voltage related or a specific part failure.  The most common occurrence of an issue of this type is power delivery to the cpu core. This area is powered by the core voltage pins. Further data collection is necessary to understand the environment where the failure occurs.'], 3: ['Unexpected Encoding', 'Unexpected combination of mscod/mcacod']}},
{'bankType':'PCU', 'fieldMask':0x00000000ffff0000,'AndMask':0x0000000000000402,'OrMask':0xffffffffffff0402,'genDesc':'PCU FW Errors','decode':{11264: ['PCU Error:FW -MCA_PKGC_WATCHDOG_HANG_CBZ_UP', 'There may be an issue with the transition from one C-state to another. Please check the QPI links between sockets.'], 1: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 2: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 3: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 4: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 5: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 6: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 7: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 8: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 9: ['PCU Error- Internal', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 3072: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 33024: ['PCU Error:FW - MCA_RECOVERABLE_DIE_THERMAL_TOO_HOT', 'There is an issue with the processor thermal state. A catastrophic temperature was detected. Please check that the cooling solution for the processor is working correctly.'], 16: ['PCU H/W Error: SVID error', 'This error indicates a hardware error with the VRM. Bit 20 can be set independently of the other MSCOD bits.  Either a PSI command or a VID command encountered a VRM error.  Please check the VR itself for proper operation.'], 512: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 9728: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 768: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 32: [' Generic Ubox/R2 error', 'This error code should not signal an IERR as it is a route-through of the Ubox and not PCU generated. This signalling is controled via CSR (UBOXERRCTL). See the error status registers (UBOXERRSTS and UBOXERRMISC)  for detailed information on the source of this error.'], 17408: ['PCU Error:FW -MCA_CRITICAL_VR_FAILED', 'This error is related to a VR problem. Possible VR Related failures are: SVID bus error; missing VR; misconfigured VR.'], 1280: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 17920: ['PCU Error:FW -MCA_VID_RAMP_DOWN_FAILED', ''], 29184: ['PCU Error:FW - MCA_WATCHDOG_TIMEOUT_PKGS_MASTER', 'PackageS timeout during a warm reset or during entry to S3 has been detected. There may be multiple possible reasons for this behavior.'], 18176: ['PCU Error:FW -MCA_EXCL_MODE_NO_PMREQ_CMP', ''], 2048: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 18688: ['PCU Error:FW -MCA_SVID_WRITE_REG_VOUT_MAX_FAILED', ''], 3584: ['PCU Error: FW -  MCA_CPD_UNCPD_S1_TIMEOUT ', 'This PCU error can occur as a side effect of a core machine check occurring during an S1 transition. Please check for other bank errors and if there are some core errors, this is likely the cause.'], 2560: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 19200: ['PCU Error:FW -MCA_PP1_BOOT_VID_TIMEOUT', ''], 19456: ['PCU Error:FW -MCA_AUX_BOOT_VID_TIMEOUT', ''], 19712: ['PCU Error:MCA_PP4_BOOT_VID_TIMEOUT', ''], 19968: ['PCU Error:FW -MCA_PP5_BOOT_VID_TIMEOUT', ''], 26624: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 3840: ['PCU Error: FW -  MCA_PKGS_SAFE_WP_TIMEOUT', 'A time-out occurred when changing the VID during a reset-warn flow. This may be an issue with the SVID bus or the voltage regulator.  This impacts the Vcore adjustment so the voltage regulators that are checked should be the Vcore rails.'], 20224: ['PCU Error:FW -MCA_SVID_COMMAND_ERROR', ''], 29952: ['PCU Error:FW - MCA_MSGCH_PMREQ_CMP_TIMEOUT', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 4096: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 4352: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 20992: ['PCU Error:FW - MCA_UNCORE_CCOMP_TIMEOUT ', ''], 4864: ['PCU Error:FW DMI bus training timeout', 'PCH has timed out on a DMI training event. The debug path of this problem is to understand what could cause the DMI to not train in a timely manner.  The two areas this problem would bisect to are link health issues or an issue with the PCH.  '], 26880: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 21504: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 17152: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 5376: ['PCU Error: FW - MCA_DMI_CPU_RESET_ACK_TIMEOUT', 'In DMI initialization, during reset, the processor (pcode) sends out a signal called CPU_RESET_DONE.  It then waits for the PCH to return a CPU_RESET_DONE_ACK.  This indicates that the processor timed out waiting for CPU_RESET_DONE_ACK. Things to checkfor is the interface between processor and PCH (DMI). '], 20480: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 22016: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 33536: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 5888: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 6144: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 22784: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 23040: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 20736: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 6912: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 7168: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 7424: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 4608: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 7680: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 17664: ['PCU Error:FW -MCA_ICC_MAX_NOTSUPPORTED', 'Core VR does not support the  supplied current. Verify that the VR is providing the correct current.'], 3328: ['PCU Error: FW -  MCA_IMC_FORCE_SR_S3_TIMEOUT', 'A timeout has occurred while trying to transition the memory controller into self refresh during a package S3.  This error can occur due to a memory failure type issues. Please check for DDR bus health or memory DIMM issues. There can be errors logged in the memory controller status banks. This error may be a side effect of the memory subsystem problem.'], 8192: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 34048: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 8448: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 25088: ['PCU Error:FW - MCA_INVALID_PKGS_RSP_QPI', 'The PCU has received an invalid package S response from the QPI. This may be a qpi related issue or an internal corruption event of the packet as it is transmitted from the QPI block into the PCU.'], 8960: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 9216: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 21248: ['PCU Error:FW - MCA_RESET_RCLK_PLL_UNLOCK_TIMEOUT', ''], 25856: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 26112: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 24576: ['PCU Error:FW - MCA_INVALID_PKGS_REQ_PCH', 'An improper request was received from the PCH. Please verify the health of the processor or the PCH. This may also be related to a DMI related issue.'], 26368: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 10240: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 10496: ['PCU Error:FW - MCA_SHUTDOWN_GT_VID_TIMEOUT', 'This error code indicates a VR related issue. Check the SVID sequencing and outputs.'], 27136: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 11008: ['PCU Error:FW - MCA_PKGC_WATCHDOG_HANG_CBZ_DOWN', 'There may be an issue with the transition from one C-state to another. Please check the QPI links between sockets.'], 24832: ['PCU Error:FW - MCA_INVALID_PKGS_REQ_QPI', 'The PCU has received an invalid package S state request. This may be a qpi related issue or an internal corrution event of the packet as it is transmitted from the QPI block into the PCU.'], 11520: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 18432: ['PCU Error:FW MCA_SVID_READ_REG_ICC_MAX_FAILED', ''], 11776: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 21760: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 28672: ['PCU Error:FW - MCA_WATCHDOG_TIMEOUT_PKGC_SLAVE', "The PCU has detected a package C slave time out condition while waiting for a PmRsp from the master. There may be an issue with the PM 'master' in the cycle. To debug this sort of problem, the pm master has to be identified and the a trace of the power management handshake process has to be monitored.  If there are QPI related issues that accompany this error, the two may be related as the QPI bus is used to transmit the PM packet handshakes."], 2304: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 28928: ['PCU Error:FW - MCA_WATCHDOG_TIMEOUT_PKGC_MASTER', 'The PCU has detected a package C master time out condition while waiting for a PmRsp from the PCH. There  may be an issue with the PCH side of the transaction. One will have to check for the PCH status and why it was unable to respond with a PmRsp.'], 12800: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 29440: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 29696: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 13568: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 25344: ['PCU Error:FW - MCA_INVALID_PKGC_RSP_PCH', 'The PCU has reived an invalid package C response from the PCH. This is either a PCH related issue or a DMI related problem.'], 13824: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 14080: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 14336: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 22272: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 14592: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 25600: ['PCU Error:FW -MCA_INVALID_PKG_STATE_CONFIG', 'The package state configuration was found to be invalid. Please check the values used to initialize GLOBAL_PKG_C_S_CONTROL_REGISTER and/or GLOBAL_NID_MAP_REGISTER'], 2816: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 31744: ['PCU Error:FW - MCA_SVID_COMMAND_ERROR', ''], 32000: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 9472: ['PCU Error: FW - SVID Timeout ', 'An SVID command time-out was detected. Please check the SVID bus or the VR as to why the timeout occurred.'], 22528: ['PCU Error:FW - Internal Error', 'This error code is a PCU reported internal error. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment). If this error is not accompanied by any other bank errors, it is a possible part specific issue.'], 32256: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).'], 32512: ['PCU Error:FW - Unexpected Encoding', 'This error code is not expected for this processor (IVYBridge EN/EP/EX).']}},
{'bankType':'QPI', 'fieldMask':0x00000000ffff0000,'AndMask':0x00000000ffff0000,'OrMask':0xffffffff0000ffff,'genDesc':'QPI Errors','decode':{0: ['QPI Error - Phy Control Error', ''], 32: ['QPI Error - Correctable: Phy Initialization Abort', "QPI Link was not able to go through a normal training sequence and had to be aborted and reattempted. The errors are logged in 'QPIREUT_PH_PPS' for the particular port [B: 1 D:[9:8] F:3 O:144h. This register is the Phy later previous initialization status and it captures state information related to the aborted sequence. One will have to have some knowledge of QPI link training to make use of this information. There are good writeups of link training debug in the platform debug handbook."], 2: ['QPI Error - Physical Layer Detected Drift Buffer Alarm', 'QPI Error - Drift buffer Overrun. Additional debug information is stored in QPIREUT_PH_PLS  register.  Bits 20:16 log the first lane to report a drift buffer alarm. Bits 6-4 also have additional drift buffer statusing.  An error of this type may point to an electrical issue the other register info may help for isolation.'], 3: ['QPI Error - Physical Layer Detected Latency Buffer Rollover', 'QPI Error - Latency buffer Over/Under run. Additional debug information is stored in the QPIREUT_PH_PLS register (bit 2).  This error code should only occur in cases or instances where latency fixing is being performed on the platform.  The implication is that the latency values shoudl be adjusted (lengthen) to ensure that the buffers are not being overrun.'], 48: ['QPI Error - Correctable: Rx CRC Error with LLR Success no Phy reset', ' A QPI Rx CRC Error which required a link level retry  has been detected.  Escalation to a physical layer reinitialization was not necessary.  This is considered a temporary physical layer event.'], 49: ['QPI Error - Correctable: Tx CRC Error', 'QPI Tx received a link level retry. This error is normally recommend to be disabled as it is a side effect of Rx CRC error on the other end of the QPI link. This is considerd a temporary soft error type of event.'], 35: ['QPI Error - Correctable: Rx CRC Error with LLR success after phy reset', 'QPI Physical Layer detected a QPI inband reset which resulted in a Width Change . This is not supported on HSX-EN/EP and should never be seen in those SKUs.  For HSX-EX, this code may be reported for a clock fail over event.  To identify the failed lane, check the QPIREUT_PH_TDS/RDS registers. '], 33: ['QPI Error - Correctable: Phy Inband Reset and Width Degradation ', 'QPI Physical Layer detected a QPI inband reset which resulted in a Width Change (lane failover). This is not supported on HSX-EN/EP and should never be seen in those SKUs.  For HSX-EX, this code may be reported for a link fail over event.  To identify the failed lane, check the QPIREUT_PH_TDS/RDS registers.\n\nNote for IVT/HSX - this error code will pretty much always be overwritten by 0x31 plesae consult the TDS/RDS registers to isolate the details of the width change.  '], 34: ['QPI Error - Correctable: Phy Inband Reset and no width change', 'QPI Physical Layer detected a QPI inband reset. Width did not change. One failure in isolation is normally not a concern, repeated failures and logging of this error code would imply link health issues.'], 50: ['QPI Error - TX Detected CRC', 'This error code is legal and valid but normally not expected as it is recommended that masking is used to disable this error logging and escalation.  The first thing to check for is proper mode (did we want to disable this escalation or not). If the intent was to disable the logging/signalling then it becomes an exercise in calculating the recipe to mask the error. This is normally defined in the BIOS writers guide.'], 16: ['QPI Error - Link Layer Detected Control Error from R3QPI ', 'QPI link layer detected control error or R3QPI error. This type of error should be a very rare event under normal operating conditions.   It is possible for a credit configuration issue can generate this error code. A credit issue can translate to overrun or underflow of a R3QPI internal buffering structure.  Another possibility is that there mayb e a parity error in the same structures in EP sku platforms when Viral is not enabled).'], 17: ['QPI Error - Failed Link Layer Retry', 'QPI Rx detected a CRC error and was not able to recover through Link Layer Replay and Re-Init (LLR Abort state). Essentially the link could not recover from a detected CRC error. This could be an interface issue (bus or bus margin) or some environmental factor (pin/socket issues) or an issue with a specific part.'], 18: ['QPI Error - Unsupported/Undefined Packet', 'QPI Link Layer detected an unsupported/undefined packet (e.g. RSVD_CHK, message class, op code, VN, viral). An error of this type that is not accompanied by CRC errors is a link layer issue (not physical layer problem). This implies potential programming or interface to another agent (node controller) that may incorrectly fill in fields of the packet.'], 19: ['QPI Error - Link Layer Control Error', 'Generic QPI Link Layer Error which cannot be resolved. Most occurrences are bi-product of poor general link health.'], 20: ['QPI Error - Link Layer L0p Retrain Error', 'This error condition is not expected on HSX platforms. HSX behavior is to trigger an inband reset flow on this condition (this differs from previous generations).  If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment).'], 21: ['QPI Error - Link Layer RBT Error', 'Route Back Table (RBT) error. Uninitialized value used. The implication is that the RBT has not been programmed correctly.  Check the RBT programming sequence to verify that this process has been completed by the platform FW and that this has been done correctly.'], 22: ['QPI Error - Reserved', 'This error should not be visible, it is reserved for IVB-EP/EX usage. It is not expected to be seen on this platform. If this code appears in an error, other mca bank values should also be checked to ensure the processor is running in a normal or linear mode ( proper voltage, frequency and power operational environment).'], 31: ['QPI Error - Unsupported Configuration Request from Message Channel', 'QPI Configuration access crossing a 32 bit boundary.  The QPI subsystem on the socket has received a configuration request that crosses a 32 bit boundary. This is not allowed. ']}},
{'bankType':'IIO', 'fieldMask':0x00000000ffff0000,'AndMask':0x000000000000ffff,'OrMask':0xffffffffffff0000,'genDesc':'IIO Generic Error','decode':{0: ['Generic Error', 'See PCIe error status values for specific decoders.  This is an EX SKU feature only.  The MCI_MISC register logs  bus, device, function logs.  This should allow for isolation and correlation of machine check banks to PCIe error status registers. ']}},
{'bankType':'HA', 'fieldMask':0x00000000ffff0000,'AndMask':0x00000000ffff0000,'OrMask':0xffffffff0000ffff,'genDesc':'Home Agent Error','decode':{32: ['Internal parity error in Home Agent', 'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 1: ['HA Error - Read Data Error ', 'Memory controller read error logged. Note the corrected or uncorrected status in bit 61 of MC_STATUS.  The channel number is logged as part of the MCACOD value. If the error is corrected the corrected error count should note the number of events that have occurred since power on. \n\nIf CMCI is enabled, this count may appear to be the value of the threshold that was set for CMCI signaling. This is because the interrupt will occur on the threshold value and the CMCI handler would normally log the value and clear it.  Note what system configuration has been enabled (CMCI enabled and what the threshold was set to) in order to get an accurate picture of the problem.'], 2: ['HA Error - Data Buffer Parity', 'HA data buffer parity error.  This error represents a bit flip in the data buffer or a parity error on the read path from iMC to HA.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 4: ['HA Error - Partial Write', 'A partial memory write error has occurred. This is due to an underfill read error.'], 8: ['HA Error - Rx timing violation', 'Data from the MC to the HA has violated a timing restriction.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 64: ['Internal parity error in Home Agent', 'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 128: ['Internal parity error in Home Agent', 'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 256: ['Internal parity error in Home Agent', 'Internal parity error.  This type of error should be a rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 16: ['HA Error - RTID Out of Range', 'An RTID value was generated and checked to be out of range by the HA. The RTID source is either the Cbo or QPI. The error is either an internally generated error (Cbo in the same socket as the HA) or external (via QPI).'], 512: ['HA Error - BT_timeout_error', "HA Backup tracker timeout error. A HA transaction has timed out. There is little tracking information logged in the MCA status banks for this. If the source of this transaction was local to this socket a corresponding Cbo Timeout should have occurred. If the transaction was from a remote socket, that socket's Cbo Timeout would have expired (check the MCA banks for that socket). If the source transaction is from a node controller device, then it's timeout mechanism should be consulted for the source transaction. This error code and bank error is used more for helping with the fault isolation. In some cases the opcode of the transction is logged in the MCi_MISC field. If this is valid the decode would appear there."]}},
{'bankType':'IMC', 'fieldMask':0x00000000ffff0000,'AndMask':0x00000000ffff0000,'OrMask':0xffffffff0000ffff,'genDesc':'Integrated Memory Controller Error','decode':{64: ['iMC Error - Sparring [Uncorrected]', "A memory sparing event has occurred and the error is uncorrected.  Address is logged in MCx_Address. In the case of poison enabled mode (advanced SKU's only), this error may be escalated to a CMCI and 'deferred'. This would be spelled out in the S and AR bits of the MCi_STATUS banks. As such, CMCI 'rules' apply here.  Similar to corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS."], 32: ['iMC Error - Sparing [Corrected]', 'A memory sparing event has occurred and the error is corrected. As with all corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.'], 2: ['iMC Error - Data Write Parity Error', ''], 4: ['iMC Error - Bye Enable Parity Error', ''], 1: ['iMC Error - Address/command Parity Error', 'iMC an error occurred in the  address/command parity error has been detected. This is detected by the DIMM and signaled back to the iMC. Note the channel number from the Mci_STATUS bank information and isolate to the DIMM for further fault isolation.'], 8: ['iMC Error - Patrol Scrub Error [Corrected]', 'The patrol scrubber has detected an error and corrected it.  Address logged in MCx_Address bank.  As with all corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS.'], 128: ['iMC Error - Read [Corrected]', ''], 256: ['iMC Error - WDB Parity', ''], 16: ['iMC Error - Patrol Scrub Error [Uncorrected]', "The patrol scrubber has detected an uncorrected error. Address is logged in MCx_Address. In the case of poison enabled mode (advanced SKU's only), this error may be escalated to a CMCI and 'deferred'. This would be spelled out in the S and AR bits of the MCi_STATUS banks. As such, CMCI 'rules' apply here.  Similar to corrected error flows, it is possible for the operating system to enable CMCI escalation and logging. The value of the Mci_STATUS bank has to bear the context of CMCI behavior related to the OS handler (read, log and clear). If the OS has enabled CMCI then the full context would have to be taken with other log data. This would give you the full detail of corrected error rate information. This applies as well to the MCi_ADDR register. It may be logged and cleared by the OS."], 512: ['iMC - Error - VMSE Related Error [Corrected]', 'These are corrected errors and no signalling of MCERR occurs. If CMCI is enabled, signalling will occur via that path. The MCI_MISC [4:0] register contains further decode of the error type. The decode is listed here for completeness [0x08: Northbound Persistent, 0x10: Southbound Persistent, 0x04 DIMM Register Parity , 0x02: Error Observed, 0x01: Link Fail]']}},
{'bankType':'Cbo/LLC', 'fieldMask':0x00000000ffff0000,'AndMask':0x00000000ffff0000,'OrMask':0xffffffff0000ffff,'genDesc':'LLC Errors','decode':{1: ['Cbo Error - UC Data Err - Crd (UCNA)', 'LLC has detected an uncorrected error (multibit) the data array. The transaction type that caused the error are logged in the MCACOD section of the MCi_STATUS bank.  Errors of this sort are expected but are deemed to be rare.  If the occurrence of these errors are frequent, steps should be take to isolate the problem to a specific part or some other system contribution (uncore power delivery or voltage).'], 2: ['Cbo Error - UC Tag Err', 'The LLC has detected an uncorrected error (multibit)  in the tag array. The transaction type that caused the error are logged in the MCACOD section of the MCi_STATUS bank.  Errors of this sort are expected but are deemed to be rare.  If the occurrence of these errors are frequent, steps should be take to isolate the problem to a specific part or some other system contribution (uncore power delivery or voltage).'], 3: ['Cbo Error - SAD ERR WBMto_type (VGA, PAM )', 'This error occurs when the SAD detects an implicit or explicit writeback to  the following regions areas that are deemed to be illegal : 1) Explicit Writeback access to true VGA range or 2) Implicit/Explicit Writeback to PAM region that does not map to non-DRAM.  These errors are likely software generated and the offending code will have to be isolated (memory mapping software).'], 4: ['Cbo Error - Internal', ''], 5: ['Cbo Error - SAD ERR Corrupting', 'This is caused by 1) Set Monitor transaction to MMIO space 2) Cacheable read to VGA region 3) PCIE to SMM: violation that IIO is trying to access CSEG region (VGA region is mapped for CSEG/SMM) 4) SMM RspM: Implicit WB data when VGA/CSEG range is mapped to true VGA 5) CrabRspM: Implicit WB to CRAB_Abort range of MMCFG range. Check for these error conditions in software.'], 6: ['Cbo Error - SAD ERR Non Corrupting', 'This error is signaled when a CLFlush occurs to VGA/CSEG region of memory. This is not allowed and suggests an incorrect cacheability region to VGA/CSEG.'], 7: ['Cbo Error - Corrected Data Error', 'The LLC has detected and corrected (single bit error in data) an error. The LLC does implement Threshold based Error Status (TES) tracking. Please check the Mci_STATUS bits [54:53] for the code that represents the severity of the corrected error (green or yellow). Since this is a corrected error, it is possible that the operating system will have enabled CMCI signaling. This implies a few system operation type of issues that impact the debug flow. If the CMCI threshold is set to 1, and this log is extracted from an Operating system, then each error will represent a count of 1 (as the OS will read, log and clear the bits for each interrupt). The status of the TES bits are the best guideline for the issue. It should also be noted that errors of this sort are expected but are deemed to be rare. If the occurrence rate is large (TES reports yellow), steps should be take to isolate the problem to a specific part or some other system contribution (core power delivery or voltage).'], 8: ['Cbo Error - Internal', ''], 10: ['Cbo Error - Uncorrected Parity Error', 'The LLC has detected a parity error on the ring interface. This is an uncorrected error.  This type of error should be a very rare event in normal operating conditions.  If this error is repeatable in any domain, is likely core voltage related or a specific part failure.  Please take steps to isolate the problem to a specific part or system. Gathering further information on the failure environment may also  be useful [Power management dependency for instance].'], 11: ['Cbo Error - Internal', ''], 12: ['Cbo Error - TOR_TIMEOUT', "The Cbo Table of Request (TOR) timer has expried on a transaction. This status value should be accompanied by valid MISC and ADDR bank register values. The transaction address and type are encoded in those registers. The MISC register will log the: Core ID, Thread ID, Cacheability, Original Request and Opcode.  The Original Request field should be used to note the request type. The opcode field will likley state a TOR Timeout and may not be as useful.  The ADDR register contains the target physical address. It should be noted that the address field does not have byte granularity (lower 6 bits are not decoded). this will make exact access difficult, but we get into the right area. The process for this error is to isolate the Original request, core/thread id and address and to map them back via a system memory mapping function. This is normally taken from the system when it boots up again. \n\nThis decode is normally accompanied by an MLC (three strike timeout) machine check. The address logged in that bank will log the EIP value at the time of the three strike. The core id logged in the Cbo timeout MISC register should align with the core MLC machine check. In the case of multiple 'hits' this may be used to correlate multiple stuck transactions to the cores that allocated these transactions."], 13: ['Cbo Error - Internal', ''], 14: ['Cbo Error - Internal', ''], 15: ['Cbo Error - Internal', ''], 17: ['Cbo Error - Internal', ''], 18: ['Cbo Error - Internal', ''], 19: ['Cbo Error - Internal', ''], 20: ['Cbo Error - Internal', ''], 21: ['Cbo Error - Internal', ''], 22: ['Cbo Error - Internal', ''], 23: ['Cbo Error - MSCOD_MULT_LLC_WAY_TAG_MATCH', 'This code represents a multiple tag match in the LLC lookup. An error of this type is normally associated with a soft error. This type of error should be very rare. If the error is not rare, then possible paths for isolation are to look at a part specific issur or platform power delivery to the part. In both cases they may be accompanied by other errors reported. If viral is enabled (EX), this error will trigger an event.'], 24: ['Cbo Error - MSCOD_REQ_RTID_TABLE_MISS_DATA', ''], 25: ['Cbo Error - MSCOD_REQ_RTID_TABLE_MISS_NON_DATA', ''], 26: ['Cbo Error - MSCOD_REQ_RTID_TABLE_MULTIHIT_DATA', ''], 27: ['Cbo Error - MSCOD_REQ_RTID_TABLE_MULTIHIT_NON_DATA', ''], 28: ['Cbo Error - Internal', ''], 29: ['Cbo Error - Internal', ''], 30: ['Cbo Error - Internal', ''], 31: ['Cbo Error - Internal', '']}},
    ]

    
_mcRegs = {0:{"type":"core",    "name":"IFU",  "ctl":"mc0_ctl_fe_ifu",   "ctl2":None,               "status":"mc0_status_fe_ifu",   "addr":"mc0_addr_fe_ifu", "misc":"mc0_misc_fe_ifu",  "misc2":"mc0_misc2_fe_ifu"},
           1:{"type":"core",    "name":"DCU",  "ctl":"mc1_ctl_meu_dcu",  "ctl2":None,               "status":"mc1_status_meu_dcu",  "addr":"mc1_addr_meu_dcu", "misc":"mc1_misc_meu_dcu",  "misc2":"mc1_misc2_meu_dcu"},
           2:{"type":"core",    "name":"DTLB", "ctl":"mc1_ctl_meu_dcu",  "ctl2":None,               "status":"mc2_status_meu_dtctls", "addr":"mc1_addr_meu_dcu", "misc":"mc1_misc_meu_dcu",  "misc2":"mc1_misc2_meu_dcu"},
           3:{"type":"core",    "name":"MLC",  "ctl":"mc3_ctl_meu_ml2",  "ctl2":None,               "status":"mc3_status_meu_ml2",  "addr":"mc3_addr_meu_ml2", "misc":"mc3_misc_meu_ml2",  "misc2":"mc3_misc2_meu_ml2"},
           # virtual msr merged banks are 4/5
           4:{"type":"uncore",  "name":"PCU",  "ctl":"mc_ctl_46",        "ctl2":"mc_ctl2_46",       "status":"mc_status_46",            "addr": None,  "misc":None,   "misc2":None},
           5:{"type":"uncore",  "name":"QPI0/1 Merged", "ctl":"merged_qpi_bank_ctl_virtual_msr",  "ctl2":"merged_qpi_bank_ctl2_virtual_msr", "status":"merged_qpi_bank_status_virtual_msr",      "addr":"merged_qpi_bank_addr_virtual_msr",  "misc":"merged_qpi_bank_misc_virtual_msr", "misc2":None},
           6:{"type":"uncore",  "name":"IIO",  "ctl":"pxp1_mc_ctl",      "ctl2":"pxp1_mc_ctl2",     "status":"pxp1_mc_status",      "addr":None,    "misc":"pxp1_mc_misc",   "misc2":None},
           7:{"type":"uncore",  "name":"HA0",  "ctl":"ha0_mc5_ctl",      "ctl2":"ha0_mc5_ctl2",     "status":"ha0_mc5_status",      "addr":"ha0_mc5_addr",    "misc":"ha0_mc5_misc",     "misc2":None},
           8:{"type":"uncore",  "name":"HA1",  "ctl":"ha1_mc5_ctl",      "ctl2":"ha1_mc5_ctl2",     "status":"ha1_mc5_status",      "addr":"ha1_mc5_addr",    "misc":"ha1_mc5_misc",     "misc2":None},
           9:{"type":"uncore",  "name":"iMC0 C0", "ctl":"imc0_epmcdp01_imc0_mc_ctl", "ctl2":"imc0_epmcdp01_imc0_mc_ctl2", "status":"imc0_epmcdp01_imc0_mc_status", "addr":"imc0_epmcmain_imc0_mc8_addr", "misc":"imc0_epmcdp01_imc0_mc_misc", "misc2":None},
           10:{"type":"uncore", "name":"iMC0 C1", "ctl":"imc0_epmcdp01_imc1_mc_ctl", "ctl2":"imc0_epmcdp01_imc1_mc_ctl2", "status":"imc0_epmcdp01_imc1_mc_status", "addr":"imc0_epmcmain_imc1_mc9_addr", "misc":"imc0_epmcdp01_imc1_mc_misc", "misc2":None},
           11:{"type":"uncore", "name":"iMC0 C2", "ctl":"imc0_epmcdp23_imc0_mc_ctl", "ctl2":"imc0_epmcdp23_imc0_mc_ctl2", "status":"imc0_epmcdp23_imc0_mc_status", "addr":"imc0_epmcmain_imc2_mca_addr", "misc":"imc0_epmcdp23_imc0_mc_misc", "misc2":None},
           12:{"type":"uncore", "name":"iMC0 C3", "ctl":"imc0_epmcdp23_imc1_mc_ctl", "ctl2":"imc0_epmcdp23_imc1_mc_ctl2", "status":"imc0_epmcdp23_imc1_mc_status", "addr":"imc0_epmcmain_imc3_mcb_addr", "misc":"imc0_epmcdp23_imc1_mc_misc", "misc2":None},
           13:{"type":"uncore", "name":"iMC1 C0", "ctl":"imc0_epmcdp01_imc0_mc_ctl", "ctl2":"imc0_epmcdp01_imc0_mc_ctl2", "status":"imc1_epmcdp01_imc0_mc_status", "addr":"imc1_epmcmain_imc0_mc8_addr", "misc":"imc1_epmcdp01_imc0_mc_misc", "misc2":None},
           14:{"type":"uncore", "name":"iMC1 C1", "ctl":"imc0_epmcdp01_imc1_mc_ctl", "ctl2":"imc0_epmcdp01_imc1_mc_ctl2", "status":"imc1_epmcdp01_imc1_mc_status", "addr":"imc1_epmcmain_imc1_mc9_addr", "misc":"imc1_epmcdp01_imc1_mc_misc", "misc2":None},
           15:{"type":"uncore", "name":"iMC1 C2", "ctl":"imc0_epmcdp23_imc0_mc_ctl", "ctl2":"imc0_epmcdp23_imc0_mc_ctl2", "status":"imc1_epmcdp23_imc0_mc_status", "addr":"imc1_epmcmain_imc2_mca_addr", "misc":"imc1_epmcdp23_imc0_mc_misc", "misc2":None},
           16:{"type":"uncore", "name":"iMC1 C3", "ctl":"imc0_epmcdp23_imc1_mc_ctl", "ctl2":"imc0_epmcdp23_imc1_mc_ctl2", "status":"imc1_epmcdp23_imc1_mc_status", "addr":"imc1_epmcmain_imc3_mcb_addr", "misc":"imc1_epmcdp23_imc1_mc_misc", "misc2":None},
           17:{"type":"uncore", "name":"CBO0", "ctl":"cbo0_mc_ctl", "ctl2":None, "status":"cbo0_mc_status", "addr":"cbo0_mc_addr", "misc":"cbo0_mc_misc", "misc2":"cbo0_mc_misc2"},
           18:{"type":"uncore", "name":"CBO1", "ctl":"cbo1_mc_ctl", "ctl2":None, "status":"cbo1_mc_status", "addr":"cbo1_mc_addr", "misc":"cbo1_mc_misc", "misc2":"cbo1_mc_misc2"},
           19:{"type":"uncore", "name":"CBO2", "ctl":"cbo2_mc_ctl", "ctl2":None, "status":"cbo2_mc_status", "addr":"cbo2_mc_addr", "misc":"cbo2_mc_misc", "misc2":"cbo2_mc_misc2"},
           20:{"type":"uncore", "name":"CBO3", "ctl":"cbo3_mc_ctl", "ctl2":None, "status":"cbo3_mc_status", "addr":"cbo3_mc_addr", "misc":"cbo3_mc_misc", "misc2":"cbo3_mc_misc2"},
           21:{"type":"uncore", "name":"CBO4", "ctl":"cbo4_mc_ctl", "ctl2":None, "status":"cbo4_mc_status", "addr":"cbo4_mc_addr", "misc":"cbo4_mc_misc", "misc2":"cbo4_mc_misc2"},
           22:{"type":"uncore", "name":"CBO5", "ctl":"cbo5_mc_ctl", "ctl2":None, "status":"cbo5_mc_status", "addr":"cbo5_mc_addr", "misc":"cbo5_mc_misc", "misc2":"cbo5_mc_misc2"},
           23:{"type":"uncore", "name":"CBO6", "ctl":"cbo6_mc_ctl", "ctl2":None, "status":"cbo6_mc_status", "addr":"cbo6_mc_addr", "misc":"cbo6_mc_misc", "misc2":"cbo6_mc_misc2"},
           24:{"type":"uncore", "name":"CBO7", "ctl":"cbo7_mc_ctl", "ctl2":None, "status":"cbo7_mc_status", "addr":"cbo7_mc_addr", "misc":"cbo7_mc_misc", "misc2":"cbo7_mc_misc2"},
           25:{"type":"uncore", "name":"CBO8", "ctl":"cbo8_mc_ctl", "ctl2":None, "status":"cbo8_mc_status", "addr":"cbo8_mc_addr", "misc":"cbo8_mc_misc", "misc2":"cbo8_mc_misc2"},
           26:{"type":"uncore", "name":"CBO9", "ctl":"cbo9_mc_ctl", "ctl2":None, "status":"cbo9_mc_status", "addr":"cbo9_mc_addr", "misc":"cbo9_mc_misc", "misc2":"cbo9_mc_misc2"},
           27:{"type":"uncore", "name":"CBO10", "ctl":"cbo10_mc_ctl", "ctl2":None, "status":"cbo10_mc_status", "addr":"cbo10_mc_addr", "misc":"cbo10_mc_misc", "misc2":"cbo10_mc_misc2"},
           28:{"type":"uncore", "name":"CBO11", "ctl":"cbo11_mc_ctl", "ctl2":None, "status":"cbo11_mc_status", "addr":"cbo11_mc_addr", "misc":"cbo11_mc_misc", "misc2":"cbo11_mc_misc2"},
           29:{"type":"uncore", "name":"CBO12", "ctl":"cbo12_mc_ctl", "ctl2":None, "status":"cbo12_mc_status", "addr":"cbo12_mc_addr", "misc":"cbo12_mc_misc", "misc2":"cbo12_mc_misc2"},
           30:{"type":"uncore", "name":"CBO13", "ctl":"cbo13_mc_ctl", "ctl2":None, "status":"cbo13_mc_status", "addr":"cbo13_mc_addr", "misc":"cbo13_mc_misc", "misc2":"cbo13_mc_misc2"},
           31:{"type":"uncore", "name":"CBO14", "ctl":"cbo14_mc_ctl", "ctl2":None, "status":"cbo14_mc_status", "addr":"cbo14_mc_addr", "misc":"cbo14_mc_misc", "misc2":"cbo14_mc_misc2"},
           32:{"type":"uncore", "name":"QPI0", "ctl":"qpi0_qpi_mc_ctl",  "ctl2":"qpi0_qpi_mc_ctl2", "status":"qpi0_qpi_mc_st",      "addr":"qpi0_qpi_mc_ad",  "misc":"qpi0_qpi_mc_misc", "misc2":None},
           33:{"type":"uncore", "name":"QPI1", "ctl":"qpi1_qpi_mc_ctl", "ctl2":None, "status":"qpi1_qpi_mc_st", "addr":"qpi1_qpi_mc_ad", "misc":"qpi1_qpi_mc_misc", "misc2":"qpi1_qpi_mc_ctl2"},
           34:{"type":"uncore", "name":"QPI2", "ctl":"qpi2_qpi_mc_ctl", "ctl2":None, "status":"qpi2_qpi_mc_st", "addr":"qpi2_qpi_mc_ad", "misc":"qpi2_qpi_mc_misc", "misc2":"qpi2_qpi_mc_ctl2"},
            }

# ##########
# Name: _bits()
#
# The usual helper bits() function from ITP, returns a subset of the input register
# vector ased on the bit position and number of bits to return.
#
def _bits(inReg, bitPos, numBits):
    bitMask = (2 ** numBits) -1
    return ((inReg >> bitPos) & bitMask)
    

class _mcaBankInfo():
    def __init__(self):
        self.bankNum       = 0
        self.bankName      = ""
        self.sktNum        = 0
        self.coreNum       = 0
        self.ctl           = 0
        self.ctl2          = 0
        self.addr          = 0
        self.misc          = 0
        self.misc2         = 0
        self.status        = 0
        self.addr_shadow0  = 0
        self.addr_shadow1  = 0
        self.misc_shadow   = 0
        self.status_shadow = 0
        self.outInfotitle=""

#
# pass in bank num and reg value
#      
def _decodeMCAMiscReg(bank,misc):
    # Try a set of bank checks and direct code first
    # we may move to function calls for each misc bank.
    # may also want to move to banktype instead of bank number...more generic
    #
    if (bank == 0):
        # IFU
        print "  [8:6] AddrMode      = 0x%x"%_bits(misc,6,3)             
        print "  [5:0] ifu_addr_lsb  = 0x%x"%_bits(misc,0,6)     
        
    elif (bank == 1):
        # DCU
        print "  [8:6] AddrMode      = 0x%x"%_bits(misc,6,3)             
        print "  [5:0] RecAddrLsb    = 0x%x"%_bits(misc,0,6)     
        
    elif (bank == 3):
        # MLC
        print "  [23:23] Thread      = 0x%x"%_bits(misc,23,1)
        print "  [22:20] Way         = 0x%x"%_bits(misc,20,3)
        print "  [19:16] Sqid        = 0x%x"%_bits(misc,16,4)
        print "  [15:9] Opcode       = 0x%x"%_bits(misc,9,7)
        print "  [8:6] AddrMode      = 0x%x"%_bits(misc,6,3)
        print "  [5:0] RecAddrLSB    = 0x%x"%_bits(misc,0,6)
    elif (bank in range (4,6)):
        # QPI - note bank 4 is PCU or QPI2, PCU has no misc reg
        #     - bank 5 is QPI 0,1
        print "  [63:53] NERR                    = 0x%x"%_bits(misc,53,11)
        print "  [52:52] FLIT_Valid              = 0x%x"%_bits(misc,51,1)
        print "  [51:32] FLIT_19_0               = 0x%x"%_bits(misc,32,20)
        print "  [26:26] L0sExitNonNull          = 0x%x"%_bits(misc,26,1)
        print "  [25:25] LL_Quiesced             = 0x%x"%_bits(misc,25,1)
        print "  [24:24] GV Retry                = 0x%x"%_bits(misc,24,1)
        print "  [23:23] Phy Layer Reset         = 0x%x"%_bits(misc,23,1)
        print "  [21:21] Early Inject Error Case = 0x%x"%_bits(misc,21,1)
        print "  [20:20] Flit L state in phy layer = 0x%x"%_bits(misc,20,1)
        print "  [19:15] FLIT_39_35              = 0x%x"%_bits(misc,15,5)
        print "  [14:6]  FLIT_28_20              = 0x%x"%_bits(misc,6,9)
        print "  [5:5]   FLIT_58                 = 0x%x"%_bits(misc,5,1)
        print "  [4:3]   FLIT_41_40              = 0x%x"%_bits(misc,3,2)
        print "  [2:1]   FLIT_61_60              = 0x%x"%_bits(misc,1,2)
        print "  [0:0]   FLIT_IIB_59             = 0x%x"%_bits(misc,0,1)
    elif (bank == 6):
        # IIO
        print "  [31:24] Bus_Log      = 0x%x"%_bits(misc,24,8)
        print "  [23:19] Device_Log   = 0x%x"%_bits(misc,19,5)        
        print "  [18:16] Function_Log = 0x%x"%_bits(misc,16,3)
        print "  [15:8]  Segment_Log  = 0x%x"%_bits(misc,8,8)        
    elif (bank in range(7,9)):
        # HA
        print "  [51:43] BTID0           = 0x%x"%_bits(misc,43,9)
        print "  [42:42] Mirror Chanel Corrected Error = 0x%x"%_bits(misc,42,1)        
        print "  [41:41] Failover Error  = 0x%x"%_bits(misc,41,1)
        print "  [40:39] HA Data Buffer Bank Parity Error  = 0x%x"%_bits(misc,39,2)   
        print "  [38:37] Priority        = 0x%x"%_bits(misc,37,2)   
        print "  [34:29] HA Opcode       = 0x%x"%_bits(misc,29,6)   
        print "  [28:25] RNID            = 0x%x"%_bits(misc,25,4)   
        print "  [22:17] RTID            = 0x%x"%_bits(misc,17,6)   
        print "  [15:9]  HTID            = 0x%x"%_bits(misc,9,7)   
        print "  [8:6]  AddrMode         = 0x%x"%_bits(misc,6,3)   
        print "  [5:0]  Addr LSB         = 0x%x"%_bits(misc,0,6)   
    elif (bank in range(7,17)):
        # IMC
        # not sure what to do with bits 63,62 yet
        print "  [55:51] Second Error Failing link = 0x%x"%_bits(misc,51,5)
        print "  [50:46] First Error Failing link  = 0x%x"%_bits(misc,46,5)
        print "  [45:30] Second Error Bit Mask  = 0x%x"%_bits(misc,30,16)
        print "  [29:14] First Error Bit Mask  = 0x%x"%_bits(misc,14,16)
        print "  [13:9] extra  = 0x%x"%_bits(misc,14,16)
            
    elif (bank in range(17,31+1)):
        # Cbo/LLC
        print "  [63:58] RTID        = 0x%x"%_bits(misc,58,6)
        print "  [57:52] TOR FSM     = 0x%x"%_bits(misc,52,6)
        # Decode origReq and opCode - this is very useful for hang debug 
        # so it gets special processing
        origReq = _bits(misc,43,9)
        opCode  = _bits(misc,29,9)
        # use opcode decode for OrigReq, need to check this
        # check for the key and decode if we find one
        if (origReq in _cboTorOpCodeDecode.keys()):
            print "  [51:43] OrigReq     = 0x%03x  => %s"%(origReq,_cboTorOpCodeDecode[origReq])
        else:
            print "  [51:43] OrigReq     = 0x%03x"%origReq
            
        if (opCode in _cboTorOpCodeDecode.keys()):
            print "  [37:29] OpCode      = 0x%03x  => %s"%(opCode,_cboTorOpCodeDecode[opCode])
        else:
            print "  [51:43] opCode     = 0x%03x"%opCode
            
        print "  [28:25] Core ID     = 0x%x"%_bits(misc,25,4)
        print "  [24:24] Thread ID   = 0x%x"%_bits(misc,24,1)
        print "  [23:23] Cacheable   = 0x%x"%_bits(misc,23,1)
        print "  [21:19] Cache State = 0x%x"%_bits(misc,19,3)
        print "  [18:14] Cache Way   = 0x%x"%_bits(misc,14,5)
        print "  [13:13] AllowSnoopP = 0x%x"%_bits(misc,13,1)
        print "  [11:11] VicP        = 0x%x"%_bits(misc,11,1)
        
         
 # this decode is for TOR Opcode, need to check if this
 # applies for OrigReq Opcode
_cboTorOpCodeDecode =  { 
        0x100:'snoop',
        0x101:'snoop',
        0x102:'snoop',
        0x104:'snoop',
        0x105:'snoop',
        0x108:'snoop',
        0x10a:'snoop',
        0x10f:'snoop',
        0x180:'RFO',
        0x181:'code read',
        0x182:'data read',
        0x183:'set monitor',
        0x186:'data read',
        0x187:'Partial Read',
        0x18c:'write combine invalidate line',
        0x18d:'write combine invalidate line',
        0x18e:'uncacheable read',
        0x18f:'write invalidate line',
        0x190:'prefetch RFO',
        0x191:'prefetch code',
        0x192:'prefetch data',
        0x193:'pcie request',
        0x194:'pcie request',
        0x195:'pcie request',
        0x19c:'pcie request',
        0x19d:'pcie request',
        0x19e:'pcie request',
        0x19f:'pcie request',
        0x1c4:'WbMtoI',
        0x1c5:'WbMtoE',
        0x1c8:'ItoM',
        0x1e0:'special cycle',
        0x1e1:'pcie request',
        0x1e4:'pcie request',
        0x1e5:'pcie request',
        0x1e6:'pcie request',
        0x1f3:'unlock',
        0x1f4:'interrupt acknowledge',
        0x1f5:'port out',
        0x1f6:'floating point exception',
        0x1f8:'End of level triggered interrupt',
        0x1f9:'interrupt (logically addressed)',
        0x1fa:'interrupt (physically addressed)',
        0x1fb:'interrupt priority update',
        0x1fc:'port in',
        0x1fe:'splitlock',
        0x1ff:'lock', }
 

def _decodeMCABank(error):
    """
    One Machine Check Error per bank is recorded. However each bank can have multiple error bits set.
    We shall consider each error bit set as an individual error and not a single error per bank.
    Corrected error count is printed separately

   """
    # Doing this initial status check specifically for HA case, where perhaps status was 0x0 but status_shadow was valid
    #
#    if (_bits(error.status,63,1)==1) or (_bits(error.status,59,1)==1) or (_bits(error.status,58,1)==1):
    if (_bits(error.status,63,1)==1):
        print "\n-----------------------------------------------------------------------------------------------"
        print "####IVT#"+error.outInfotitle.strip('\n')+"####"
        #print "MC_STATUS = 0x%016X"%error.status
        (miscv, addrv) = _decodeMCStatus_simple(error.status)
        print
        _MscodDebugAdvice(error.bankNum, error.status)
        print
        if (_bits(error.status,59,1) ==1):
            if miscv:
                print "MC_MISC  = 0x%016X"%error.misc
                _decodeMCAMiscReg(error.bankNum, error.misc)
                print
                if (_mcRegs[error.bankNum]["misc2"] != None):
                    print "MC_MISC2 = 0x%016X"%error.misc2
        if (_bits(error.status,58,1)==1):
            if addrv:
                print "MC_ADDR  = 0x%016X"%error.addr
        #print "-----------------------------------------------------------------------------------------------\n"
    else:
    	return -1
        #print
        #print "MC_STATUS = 0x%016X"%error.status
        #print "Not a valide MC_STATUS reg(MC_STATUS[63]=0), skipping MCA decoding...."
    if error.status_shadow==0:
    	return
    if _bits(error.status_shadow,63,1):
        _MscodDebugAdvice(error.bankNum, error.status_shadow)
        print
        if (error.bankNum == 7) or (error.bankNum == 8):
            print "####HSX#"+error.outInfotitle.strip('\n')+"####"
            print "####BANK = "+str(error.bankNum)+"####"
            print "MC_STATUS_SHADOW = 0x%016X"%error.status_shadow
            (miscv, addrv) = _decodeMCStatus_simple(error.status_shadow)
            print

        if (_bits(error.status,59,1) ==1):
            if miscv:
                print "MC_MISC_SHADOW = 0x%016X"%error.misc_shadow
        if (_bits(error.status,58,1)==1):
            if addrv:
                shadowAddr = (error.addr_shadow1 << 32) | error.addr_shadow0
                print "MC_ADDR_SHADOW = 0x%016X"%shadowAddr
    print
    #print "More detailed MCA Decode feature to be added later..."
    #print
# End _decodeMCABank()

# helper function to find the lsb that is a 1 in a bit pattern
# no checks, we assume you pass in an int value, it is used only below
#
def _findNonZeroLSB( numBits, value):
    #
    bitPos = 0
    # if we get a zero there is no lsb, return 0
    if (value == 0 or numBits == 0):
        return 0
    else:
        while (bitPos < numBits):
            # if we shift and the lsb is a 1, we are done
            if ((value >> bitPos) & 1) == 1:
                return bitPos
            else:
                bitPos = bitPos + 1
    
    return bitPos


def _MscodDebugAdvice(bank,status):
    mscod = _bits(status,16,16)
    advisory_msg = ""
    advisory_msg_bank = 0
    bankName = ''
    if (bank == 0):
        bankName = 'IFU'
    elif (bank == 1):
        bankName = 'DCU'
    elif (bank == 2):
        bankName = 'DTLB'
    elif (bank == 3):
        bankName = 'MLC'
    elif (bank == 4):
        bankName = 'PCU'
    elif (bank in [5, 32, 33]):
        bankName = 'QPI'
    elif (bank == 6):
        bankName = 'IO'
    elif (bank in [7,8]):
        bankName = 'HA'
    elif (bank in range(9,16+1)):
        bankName = 'IMC'
    elif (bank in range(17,31+1)):
        bankName = 'Cbo/LLC'
       
    print
    print "MCA bank %d - %s" %(bank, bankName)
    print

    # print 'Advice: %s' % bankName
    #
    # Loop through the decode list in the mca advice module
    # There are multiple pages for each bank type so there are two tiers
    # of this lookup process, the first is to find a match for bank type and then it is to see if 
    # the mask matches (andMask, orMask)
    #
    for item in _decodeList:
        # Find match for bankName
        if (item['bankType'] == bankName):
            # we have a bankType match, load the masks and see if there is a match
            # do an 'and' or 'or' mask of the status bits (mscod and mcacod) and see if we have a match.
            #print 'bankName Match'
            #print 'Status =%x : AndMask = %x : OrMask = %x' % (status, item['AndMask'], item['OrMask'])
            #print 'AndTestValue = %x  : OrTestValue = %x' % ((item['AndMask'] & status ), ( item['OrMask'] | status ))
            # we only check the mcacod value masks match (lowest 16 bits) 
            # if there are bits set (otherwise we only use mscod)
            if (item['AndMask'] & 0xffff == 0) or (item['OrMask'] & 0xffff == 0xffff):
                # we assume only one page (this one)
                # just extract the mscod value and check for a table entry.
                print '  MSCOD decode type title: %s' % (item['genDesc'])   
                # look up debug advice in the table of this 'item'
                # if we find a key match, we print out the title (offset 0)
                # and debug advice (offset 1)
                # we could optimize this and pass in the offsets from the advice module...
                decodeKey = (status & item['fieldMask'] ) >> _findNonZeroLSB(64,item['fieldMask']) 
                if (decodeKey in item['decode'].keys()):
                    print '  MSCOD Title: %s' % (item['decode'][decodeKey][0])
                    msg = _textwrap.wrap(item['decode'][decodeKey][1], 90)
                    for line in range(len(msg)):
                        print "  %s"%msg[line]
                else:
                    print 'No Advice found for this offset'                
            else:
                # do full 'paging' check, that is check for match with entire mask (includes mcacod field)
                if ((item['AndMask'] & status == item['AndMask']) and ( item['OrMask'] | status == item['OrMask']) ) :
                    # we have a match
                    print '  MSCOD decode type title: %s' % (item['genDesc'])   
                    # look up debug advice in the table of this 'item'
                    # if we find a key match, we print out the title (offset 0)
                    # and debug advice (offset 1)
                    decodeKey = (status & item['fieldMask'] ) >> _findNonZeroLSB(64,item['fieldMask']) 
                    if (decodeKey in item['decode'].keys()):
                        print '  MSCOD Title: %s' % (item['decode'][decodeKey][0])
                        msg = _textwrap.wrap(item['decode'][decodeKey][1], 90)
                        for line in range(len(msg)):
                            print "  %s"%msg[line]
                    else:
                        print 'No Advice found for this offset'
            

def _decodeMCStatus_simple(status):
    miscv = 0
    addrv = 0
    vStr=" "
    if _bits(status,63,1):
        print "  [63] Valid"
        if _bits(status,62,1):
            print "  [62] Overflow"
        else:
            print "  [62] No overflow"
        if _bits(status,61,1):
            print "  [61] Uncorrected error"
        else:
            print "  [61] Corrected error"
        if _bits(status,61,1) and not _bits(status,57,1):
            vFlag = True
        else:
            vFlag = False
        if _bits(status,60,1):
            print "  [60] Enabled in MC_CTL"
        else:
            print "  [60] Not enabled in MC_CTL"
        if _bits(status,59,1):
            print "  [59] MC_MISC is valid"
            miscv = 1
        else:
            print "  [59] MC_MISC is not valid"
        if _bits(status,58,1):
            print "  [58] MC_ADDR is valid"
            addrv = 1
        else:
            print "  [58] MC_ADDR is not valid"
        if _bits(status,57,1):
            print "  [57] Processor context corrupt"
        else:
            print "  [57] Processor context is NOT corrupt"
        if not vFlag:
            print "  [56] (Not valid since error was correctable or processor context is corrupt)"
        elif _bits(status,56,1):
            print "  [56] Signaled with MCERR %s"%vStr
        else:
            print "  [56] Signaled with CMCI %s"%vStr
        if not vFlag:
            print "  [55] (Not valid since error was correctable or processor context is corrupt)"
        elif _bits(status,55,1):
            print "  [55] Action required %s"%vStr
        else:
            print "  [55] No action required %s"%vStr
        if _bits(status,53,2) == 1:
            print "  [54:53] Corrected Error Status = Green"
        elif _bits(status,53,2) == 2:
            print "  [54:53] Corrected Error Status = Yellow"
        print "  [52:38] Corrected Error Count = %d"%_bits(status,38,15)
        print "  [37:32] Other Info = 0x%02x"%_bits(status,32,6)
        print "  [31:16] MSCOD = 0x%04x"%_bits(status,16,16)
        print "  [15:0]  MCACOD = 0x%04x"%_bits(status,0,16)
    else:
        print "  [63] Not valid"
    return (miscv, addrv)
# End _decodeMCStatus_simple()

#########################################################
## Manual Decode block (get user inputs and decode them)
#########################################################
#
# ##########
# Name: _getUserInput()
# Inputs:   None
# Output :  retList[] - True/False/'TestMode' (quit flag), bank, mcstatus, mcaddr, mcmisc
#

_menu = """
IVB-EN/EP/EX Manual Machine Check Bank Decoder
Enter MCi_STATUS, MCi_ADDR, MCi_MISC values
RevString: %s
Enter 't' or 'T' to run a short built-in demo
Enter 'q' or 'Q' to exit
"""%(_revString)

def _getUserInput():
    #
    #
    retList = [False]
    #
    reply = ''
    print _menu
    #
    # Get Bank number
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MC Bank Num [0..31]:')
        if (reply == 'q' or reply == 'Q'):
            return(retList)
        # hook for test vector mode
        elif (reply == 't' or reply == 'T'):  # hook for test vector mode
            retList[0] = 'TestMode'
            return (retList)
        else:
            try:
                bank = int(reply)
                tryAgain = False
            except:
                print 'Incorrect number format, bank number is decimal only, please try again..'
    #
    # Get MCi_STATUS
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_STATUS [0x0]:')
        if (reply == 'q' or reply == 'Q'):
            return(retList)
        elif (reply == ''):
            mcstatus = 0
            tryAgain = False
        else:
            try:
                mcstatus = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'
    #
    # Get MCi_ADDR
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_ADDR   [0x0]:')
        if (reply == 'q' or reply == 'Q'):
            return(retList)
        elif (reply == ''):
            mcaddr = 0
            tryAgain = False
        else:
            try:
                mcaddr = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'

    # Get MCi_MISC
    tryAgain = True
    while tryAgain:
        reply = raw_input('Enter MCi_MISC   [0x0]:')
        if (reply == 'q' or reply == 'Q'):
            return(retList)
        elif (reply == ''):
            mcmisc = 0
            tryAgain = False
        else:
            try:
                mcmisc = int(reply, 16)
                tryAgain = False
            except:
                print 'Incorrect number format: acceptable examples == [0xfe00000000800400 or fe00000000800400]'

    # spacer for the output strings later
    print '\n\n'

    retList = [True, bank, mcstatus, mcaddr, mcmisc]
    return (retList)



def _testVectors():

        print '\n\n***********************************************************************'
        print '\t\t\tTest Vectors \n'
        print '***********************************************************************\n'

        #MC1
        # bankNum   = 17
        # statusReg = 0xbe200000000c110a
        # miscReg   = 0xb0fff8160c400086
        # misc2Reg  = 0x0
        # addrReg   = 0x280
        # print 'basic first cut...'
        # ivtErrDump._decodeMCStatus_simple(statusReg)
        # ivtErrDump._MscodDebugAdvice(bankNum,statusReg)
        # print
        
        
        # define an mcabank object
        error = _mcaBankInfo()
        error.bankNum = 17
        error.bankName = ''
        error.status = 0xbe200000000c110a
        error.misc = 0xb0fff8160c400086
        error.misc2 = 0x0
        error.addr = 0x280
        # stuff object into decoder
        _decodeMCABank(error)

        # define an mcabank object - this from mca on crb
        error = _mcaBankInfo()
        error.bankNum = 5
        error.bankName = ''
        error.status = 0xC800014000310E0F
        error.misc = 0x001DF87B000D9EFF
        error.misc2 = 0x0
        error.addr = 0x0000000080500000
        # stuff object into decoder
        _decodeMCABank(error)


#
# This is the module entry point...
#
def _manualDecode():
    """
    Decodes an MCA error and prints debug advice.

    Inputs:
    
        MCA Bank Name [0..31] 
        MCi_Status value 
        MCi_ADDR value  
        MCi_MISC value   
        
        
    Output: 
    
        Decoded MCA registers, and debug advice (if available)
    
    
    Example Usage: Decode an MCA Bank 5 (QPI0) Error 
    
    
        Enter MCA Bank Name [0..31]: 5
        Enter MCi_STATUS [0x0]: 0xC800014000310E0F
        Enter MCi_ADDR   [0x0]: 0x0
        Enter MCi_MISC   [0x0]: 0x001DF87B000D9EFF
        
        
        MC_STATUS = 0xC800014000310E0F
          [63] Valid
          [62] Overflow
          [61] Corrected error
          [60] Not enabled in MC_CTL
          [59] MC_MISC is valid
          [58] MC_ADDR is not valid
          [57] Processor context is NOT corrupt
          [56] (Not valid since error was correctable or processor context is corrupt)
          [55] (Not valid since error was correctable or processor context is corrupt)
          [52:38] Corrected Error Count = 5
          [37:32] Other Info = 0x00
          [31:16] MSCOD = 0x0031
          [15:0]  MCACOD = 0x0e0f

          MSCOD decode type title: QPI Errors
          MSCOD Title: QPI Error - Correctable: Tx CRC Error
          QPI Tx received a link level retry. This error is normally recommend to be disabled as it
          is a side effect of Rx CRC error on the other end of the QPI link. This is considered a
          temporary soft error type of event.

        MC_MISC  = 0x001DF87B000D9EFF
          [63:53] NERR               = 0x0
          [52:52] FLIT_VALID         = 0x1
          [51:32] FLIT_19_0          = 0xdf87b
          [25:25] LLQUIESCE          = 0x0
          [24:24] GVRETRY            = 0x0
          [23:23] PHYRESET           = 0x0
          [21:21] EARLY_INJECT_ERR   = 0x0
          [20:20] FLIT_L_STATE       = 0x0
          [19:15] FLIT_39_35         = 0x1b
          [14:6]  FLIT_28_20         = 0x7b
          [5:5]   FLIT_58            = 0x1
          [4:3]   FLIT_41_40         = 0x3
          [2:1]   FLIT_61_60         = 0x3
          [0:0]   IIB                = 0x1

    """

    try:
        #
        keepGoing = True
        bank =0
        statusReg = 0
        addressReg = 0
        miscReg = 0
        #
        while keepGoing:
            retList = _getUserInput()
            if (retList[0] == 'TestMode'):
                _testVectors()
                keepGoing = False
            else:
                keepGoing = retList[0]
            if (keepGoing == True):
                # define an mcabank object
                error = _mcaBankInfo()
                error.bankNum = retList[1]
                error.status = retList[2]
                error.misc = retList[4]
                error.addr = retList[3]
                # stuff object into decoder
                _decodeMCABank(error)

    except:
        import traceback
        log = open('mcd_ivt.log', 'w')
        traceback.print_exc()
        traceback.print_exc(file=log)
        log.close()

def main():
    if len(sys.argv) == 1:  #run without any arguments
        _manualDecode()
        return
        
    if len(sys.argv) != 5: #provide all 4 parameters
        print "Usage: mcd_ivt.py bank_num MCi_STATUS MCi_ADD MCi_MISC"
        print "       e.g. mcd-ivt.py 3 0xC800014000310E0F 0x40000 0x001DF87B000D9EFF"
        sys.exit(2)
     
    #start the decoding
    error = _mcaBankInfo()
    error.bankNum = long(sys.argv[1])
    error.status = long(sys.argv[2], 16)
    error.addr = long(sys.argv[3], 16)
    error.misc = long(sys.argv[4], 16)
    # stuff object into decoder
    _decodeMCABank(error)

        
if __name__ == "__main__":
    main()

    