#!/usr/bin/python
# -*- coding: UTF-8 -*-

import os
import sys
#import requests
import json
import threading


PCILOCAL={
            'CPU0':{"SLOT0RT3RL0":"D2F0","SLOT1RT3RL0":"D3F2"},
            'CPU1':{"SLOT3RT1RL0":"D1F0","SLOT3RT1RL2":"D2F0","SLOT2RT3RL0":"D3F0"}
           }


PCI_IDS_LIST={
            0x1000:"LSI Logic / Symbios Logic",
            0x1002:"Advanced Micro Devices, Inc",
            0x1077:"QLogic Corp.",  
            0x10df:"Emulex Corporation",
            0x1166:"Broadcom",
            0x10de:"NVIDIA Corporation",
            0x11f8:"PMC-Sierra Inc.",
            0x19a2:"Emulex Corporation", 
            0x1fc1:"QLogic, Corp.",
            0x8086:"Intel Corporation",
            0x9005: "Avago"}

PCI_IDS_DEVICE_LIST={
            0x1000:{0x005b:"MegaRAID SAS 2208",0x005d:"MegaRAID SAS-3 3108",0x005f:"MegaRAID SAS-3 3008"},
            0x9005:{0x28d:"SAS3008IT"},
            0x8086:{0x10c9:"82576 Gigabit Network Connection",
                0x10f8:"82599 10 Gigabit Dual Port Backplane Connection",
                0x10fb:"82599ES 10-Gigabit SFI/SFP+ Network Connection",
                0x1521:"I350 Gigabit Network Connection",
                0x1529:"82599 10 Gigabit Dual Port Network Connection with FCoE",
                0x152a:"82599 10 Gigabit Dual Port Backplane Connection with FCoE"}}

ListPCIEDevType=["Other",#0x00
"Storage",#0x01
"NIC",#0x02
"GPU",#0x03
"Multimedia_Device",#0x04
"Memory",#0x05
"Bridge_Device",#0x06
"Simple_Communication_Controllers",#0x07
"Base System Peripherals",#0x08
"Input_Devices",#0x09
"Docking_Stations",#0x0a
"Processors",#0x0b
"HBA",#0x0c
"Wireless",#0x0d
"IIO",#0x0e
"Satellite Communication Controllers",#0x0f
"Encryption/Decryption_Controllers",#0x10
"Data Acquisitions and Signal Processing Controllers"]#0x11

def makeSlecetedJson(web_resp,name, index):
    nPos=web_resp.find('[')
    if nPos < 0:
    	return 1
    nPos=web_resp.find(']')
    if nPos < 0:
    	return 1
    info=web_resp.split('[')[index]
    info=info.split(']')[0]
    info='{\''+name+'\''+':'+'['+info+']}'
    info=info.replace('\'',"\"")
    return info

def getPcieInfo2Socket(pciedev):
	#print 'test getPcieInfo'
	#filePath=sys.argv[1]
	fileName="output/logsJasonRes/"+ 'getpcieinfo.asp'
        #fileName='getpcieinfo.txt'
        pciedev1=pciedev
	if False==os.path.exists(fileName):
	    	print 'File', fileName, 'Not Exist'
	    	return
	f=open(fileName, 'r+')
	tmpinfo=f.read()

	#print tmpinfo
	resp = makeSlecetedJson(tmpinfo,'pcie', 1)
	if resp == 1:
    		return
	#print resp
	json_info=json.loads(resp)
	#print 'test222'
	#print json_info
	#print json_info['mem'][0]['MemDimm']
	count=len(json_info['pcie'])-1
	#print 'test333'
	#print count
	if count >0:
		for cnt in range(count):
			if json_info['pcie'][cnt]['Present'] == 1:
			        #print  json_info['mem'][cnt]['MEMID'], json_info['mem'][cnt]['Manufacture']
				tmpIndex=json_info['pcie'][cnt]['Index']
				tmpslot=json_info['pcie'][cnt]['slot']

				tmponwhichcpu=json_info['pcie'][cnt]['onwhichcpu']
				if tmponwhichcpu == 0x80:
					tmponwhichcpu=1

				tmpType=json_info['pcie'][cnt]['type']
				if tmpType < len(ListPCIEDevType):
					tmpType=ListPCIEDevType[tmpType]

				tmpPCIEVendorId=json_info['pcie'][cnt]['VendorID']
                                #print tmpPCIEVendorId
				if None != PCI_IDS_LIST.get(tmpPCIEVendorId):
					tmpPCIEVendorId=PCI_IDS_LIST.get(tmpPCIEVendorId)
				else:
					tmpPCIEVendorId=hex(tmpPCIEVendorId)
                                tvid=json_info['pcie'][cnt]['VendorID']
				tmpPCIEDeviceId=json_info['pcie'][cnt]['DeviceID']
				if   None != PCI_IDS_DEVICE_LIST.get(tvid):
					if PCI_IDS_DEVICE_LIST.get(tvid).get(tmpPCIEDeviceId) != None:
						tmpPCIEDeviceId=PCI_IDS_DEVICE_LIST.get(tvid).get(tmpPCIEDeviceId) 
					else:
						tmpPCIEDeviceId=hex(tmpPCIEDeviceId)
				else:
					tmpPCIEDeviceId=hex(tmpPCIEDeviceId)
                                       

				tmpPCIELinkSpeed=json_info['pcie'][cnt]['Speed']
				tmpPCIELinkWidth=json_info['pcie'][cnt]['width']
                                tmpDevice= json_info['pcie'][cnt]['risertype']
				tmpFunc=json_info['pcie'][cnt]['pcielocationonraiser']
				tmpString='PCIE_'  + str(tmpslot)  + '_CPU' + str(tmponwhichcpu) + '|' + str(tmpType) + '|' + str(tmpPCIEVendorId) + '|' +  str(tmpPCIEDeviceId) +  '|'  + 'GEN'  +  str(tmpPCIELinkSpeed) + '|' + 'X' +  str(tmpPCIELinkWidth) + '|' + 'PCIE#' 
				#print tmpString
                                tmpkey="SLOT"+str(tmpslot)+"RT"+str(tmpDevice)+"RL"+str(tmpFunc)
                                #print tmpkey
                                #print  pciekey
                                cpuid="CPU"+str(tmponwhichcpu)
                                pciekey=PCILOCAL.get(cpuid).get(tmpkey)
                                if None !=pciedev1.get(cpuid):
                                  pciedev1[cpuid][pciekey]=tmpString
				f.write(tmpString)
                                

	f.close()
        #print PCI_LOCAL
        #print pciedev1
	return

#pci={}
#getPcieInfo2Socket(pci)

