#!/usr/bin/bash

if [ $# -ne 1 ]
then
    echo "input a file name."
    echo $1
    echo $1
    exit
fi
filename=$1
function getips()
{
typeOf="nothing"
ipos=""
ipbmc=""
while read line
do
    echo $line | grep -i "os"
    if [ $? -eq 0 ]
    then
        typeOf="os"
        continue
    fi
    echo $line | grep -i "bmc"
    if [ $? -eq 0 ]
    then
        typeOf="bmc"
        continue
    fi
    ip=$(echo $line | grep "[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}")
    if [ ${#ip} -ge 7 ]
    then
        if [ "$typeOf" == "os" ]
        then
            ipos="$ipos $ip"
        elif [ "$typeOf" == "bmc" ]
        then
            ipbmc="$ipbmc $ip"
        else
            continue
        fi
    fi
    tail=$(echo $line | grep -o "[0-9]\{0,3\}-[0-9]\{0,3\}")
    if [ ${#tail} -ge 3 ]
    then
        head=$(echo $line | grep -o "[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.")
        t_low=${tail%-*}
        t_high=${tail#*-}
        if [ $t_high -lt $t_low ]
        then
            return
        fi
        for((i=$t_low;i<=$t_high;i++))
        do
            if [ $typeOf == "os" ]
            then
                ipos="$ipos $head$i"
            else
                ipbmc="$ipbmc $head$i"
            fi
        done
    fi
done < $filename 
}
getips
echo "ipos="$ipos
echo "ipbmc="$ipbmc
